<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.

declare(strict_types=1);

use Migrations\AbstractMigration;

/**
 * Class SlaConsiderCheckType
 *
 * Created via:
 * oitc migrations create -p SLAModule SlaConsiderCheckType
 *
 * Run migration:
 * oitc migrations migrate -p SLAModule
 *
 */
class SlaConsiderCheckType extends AbstractMigration {
    /**
     * Change Method.
     *
     * More information on this method is available here:
     * https://book.cakephp.org/phinx/0/en/migrations.html#the-change-method
     * @return void
     */
    public function change(): void {
        $this->table('slas')
            ->addColumn('hard_state_only', 'integer', [
                'after'   => 'consider_downtimes',
                'limit'   => 1,
                'default' => 0,
                'null'    => false,
            ])
            ->update();
    }
}
