<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.

declare(strict_types=1);

use Migrations\AbstractMigration;

/**
 * Class SlaEvaluationTotalTimeAdded
 *
 * Created via:
 * oitc migrations create -p SLAModule SlaEvaluationTotalTimeAdded
 *
 * Run migration:
 * oitc migrations migrate -p SLAModule
 *
 */
class SlaEvaluationTotalTimeAdded extends AbstractMigration {
    /**
     * Change Method.
     *
     * More information on this method is available here:
     * https://book.cakephp.org/phinx/0/en/migrations.html#the-change-method
     * @return void
     */
    public function change(): void {
        $this->table('sla_availability_status_hosts')
            ->addColumn('evaluation_total_time', 'integer', [
                'after'   => 'sla_id',
                'limit'   => 11,
                'default' => 0,
                'null'    => false,
            ])
            ->update();

        $this->table('sla_availability_status_hosts_log')
            ->addColumn('evaluation_total_time', 'integer', [
                'after'   => 'sla_id',
                'limit'   => 11,
                'default' => 0,
                'null'    => false,
            ])
            ->update();

        $this->table('sla_availability_status_services')
            ->addColumn('evaluation_total_time', 'integer', [
                'after'   => 'sla_id',
                'limit'   => 11,
                'default' => 0,
                'null'    => false,
            ])
            ->update();

        $this->table('sla_availability_status_services_log')
            ->addColumn('evaluation_total_time', 'integer', [
                'after'   => 'sla_id',
                'limit'   => 11,
                'default' => 0,
                'null'    => false,
            ])
            ->update();
    }
}
