<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.

declare(strict_types=1);

use Migrations\AbstractMigration;

/**
 * Class SlaEvaluationTotalTimeAdded
 *
 * Created via:
 * oitc migrations create -p SLAModule SlaLowestDeterminedAvailabilityOfServices
 *
 * Run migration:
 * oitc migrations migrate -p SLAModule
 *
 */
class SlaLowestDeterminedAvailabilityOfServices extends AbstractMigration {
    /**
     * Change Method.
     *
     * More information on this method is available here:
     * https://book.cakephp.org/phinx/0/en/migrations.html#the-change-method
     * @return void
     */
    public function change(): void {
        $this->table('sla_availability_status_hosts')
            ->addColumn('lowest_determined_availability_of_services_percent', 'float', [
                'after'     => 'determined_availability_percent',
                'default'   => null,
                'precision' => 8,
                'scale'     => 3,
                'null'      => true,
                'comment'   => 'Lowest availability value of the services as percentage'
            ])
            ->update();
    }
}
