<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.

declare(strict_types=1);

use Migrations\AbstractMigration;

/**
 * Class HostMappingRulesAddDescription
 *
 * Created via:
 * oitc migrations create -p SLAModule HostMappingRulesAddDescription
 *
 * Run migration:
 * oitc migrations migrate -p SLAModule
 *
 */
class HostMappingRulesAddDescription extends AbstractMigration {
    /**
     * Change Method.
     *
     * More information on this method is available here:
     * https://book.cakephp.org/phinx/0/en/migrations.html#the-change-method
     * @return void
     */
    public function change(): void {
        $this->table('sla_host_mapping_rules')
            ->addColumn('description', 'string', [
                'after'   => 'hostname_regex',
                'default' => null,
                'limit'   => 2500,
                'null'    => true,
                'comment' => 'Filter by host description'
            ])
            ->update();
    }
}
