<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.

namespace SLAModule\Controller;

use Cake\ORM\TableRegistry;
use SLAModule\Model\Table\SlaSettingsTable;

class SlaSettingsController extends AppController {

    public function index() {
        if (!$this->isApiRequest()) {
            //Only ship template for AngularJs
            return;
        }

        /** @var SlaSettingsTable $SlaSettingsTable */
        $SlaSettingsTable = TableRegistry::getTableLocator()->get('SLAModule.SlaSettings');

        $sla_settings = $SlaSettingsTable->getSettings();

        if ($this->request->is('get')) {
            $this->set('sla_settings', $sla_settings);
            $this->viewBuilder()->setOption('serialize', [
                'sla_settings'
            ]);

            return;
        }


        if ($this->request->is('post')) {
            $entity = $SlaSettingsTable->getSettingsEntity();
            $entity = $SlaSettingsTable->patchEntity($entity, $this->request->getData(null, []));
            $SlaSettingsTable->save($entity);
            if ($entity->hasErrors()) {
                $this->response = $this->response->withStatus(400);
                $this->set('error', $entity->getErrors());
                $this->viewBuilder()->setOption('serialize', ['error']);
                return;
            }

            $this->set('sla_settings', $entity);
            $this->viewBuilder()->setOption('serialize', [
                'sla_settings'
            ]);
        }
    }
}