<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.


namespace itnovum\openITCOCKPIT\SLAModule\AngularAssets;


use itnovum\openITCOCKPIT\Core\AngularJS\AngularAssetsInterface;
use itnovum\openITCOCKPIT\Core\AngularJS\PluginAngularAssets;

class AngularAssets extends PluginAngularAssets implements AngularAssetsInterface {


    /**
     * @var array
     */
    protected $jsFiles = [];

    protected $cssFiles = [
        '/css/app.css'
    ];

    /**
     * @return array
     */
    public function getJsFiles() {
        // /sla_module works fine for Controller and Actions but for an unknown reason it is not working with assets
        // such as CSS or JS files.
        // As workaround /SLAModule or /s_l_a_module could be used.
        return $this->_getJsFiles('SLAModule');
    }

    /**
     * @return array
     */
    public function getCssFiles() {
        return $this->_getCssFiles('SLAModule');
    }

    /**
     * @return array
     */
    public function getJsFilesOnDisk() {
        return $this->_getJsFilesOnDisk('SLAModule');
    }

    /**
     * @return array
     */
    public function getCssFilesOnDisk() {
        return $this->_getCssFilesOnDisk('SLAModule');
    }
}
