<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.

namespace SLAModule\Lib;


use itnovum\openITCOCKPIT\Core\Menu\MenuCategory;
use itnovum\openITCOCKPIT\Core\Menu\MenuHeadline;
use itnovum\openITCOCKPIT\Core\Menu\MenuInterface;
use itnovum\openITCOCKPIT\Core\Menu\MenuLink;

class Menu implements MenuInterface {

    /**
     * @return array
     */
    public function getHeadlines() {
        $Administration = new MenuHeadline(\itnovum\openITCOCKPIT\Core\Menu\Menu::MENU_ADMINISTRATION);
        $Administration
            ->addCategory((new MenuCategory(
                'sla_category',
                __('SLA Management'),
                6,
                'fa-solid fa-file-contract'
            ))
                ->addLink(new MenuLink(
                    __('SLAs'),
                    'SlasIndex',
                    'slas',
                    'index',
                    'SLAModule',
                    'fa-solid fa-award',
                    [],
                    1
                ))
            );

        $Configuration = new MenuHeadline(\itnovum\openITCOCKPIT\Core\Menu\Menu::MENU_CONFIGURATION);
        $Configuration
            ->addCategory((new MenuCategory(
                'settings_category'
            ))
                ->addLink(new MenuLink(
                    __('SLA Globals'),
                    'SlaSettingsIndex',
                    'SlaSettings',
                    'index',
                    'SLAModule',
                    'fa fa-code',
                    [],
                    4
                ))
            );

        return [$Administration, $Configuration];
    }
}
