<?php

namespace SLAModule\Lib;

class SlaResult {

    private $success;

    /**
     * @var array
     * Contains the validation errors if it was not possible to save to one or more objects to the following tables:
     * - sla_availability_status_hosts_log
     * - sla_availability_status_services_log
     */
    private $errorsLog;

    /**
     * @var array
     * Contains the validation errors if it was not possible to save to one of the following tables:
     * - sla_availability_status_hosts
     * - sla_availability_status_services
     */
    private $errorStatus;

    public function __construct(bool $success, array $errorsLog, array $errorStatus) {
        $this->success = $success;
        $this->errorsLog = $errorsLog;
        $this->errorStatus = $errorStatus;
    }

    /**
     * @return bool
     */
    public function isSuccess(): bool {
        return $this->success;
    }

    /**
     * @return array
     */
    public function getErrorsLog(): array {
        return $this->errorsLog;
    }

    /**
     * @return array
     */
    public function getErrorStatus(): array {
        return $this->errorStatus;
    }

}
