<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.


namespace SLAModule\Lib;


use itnovum\openITCOCKPIT\Core\Dashboards\ModuleWidgetsInterface;

class Widgets implements ModuleWidgetsInterface {

    /**
     * @var array
     */
    private $ACL_PERMISSIONS = [];

    /**
     * Widgets constructor.
     * @param $ACL_PERMISSIONS
     */
    public function __construct($ACL_PERMISSIONS) {
        $this->ACL_PERMISSIONS = $ACL_PERMISSIONS;
    }

    /**
     * @return array
     */
    public function getAvailableWidgets() {
        $widgets = [];
        if (isset($this->ACL_PERMISSIONS['slamodule']['slas']['index']) && isset($this->ACL_PERMISSIONS['slamodule']['slas']['viewdetails'])) {
            $widgets[] = [
                'type_id'   => 500,
                'title'     => __('SLA Status'),
                'icon'      => 'fa-solid fa-traffic-light',
                'directive' => 'sla-widget',
                'width'     => 4,
                'height'    => 12
            ];

            $widgets[] = [
                'type_id'   => 501,
                'title'     => __('SLA Calendar Overview'),
                'icon'      => 'fa-regular fa-calendar-days',
                'directive' => 'sla-calendar-widget',
                'width'     => 4,
                'height'    => 12
            ];

            $widgets[] = [
                'type_id'   => 502,
                'title'     => __('SLA Summary'),
                'icon'      => 'fa-solid fa-table-list',
                'directive' => 'sla-summary-widget',
                'width'     => 8,
                'height'    => 12
            ];
            /*
            $widgets[] = [
                'type_id'   => 503,
                'title'     => __('SLA\'s Summary'),
                'icon'      => 'fa-solid fa-folder-open',
                'directive' => 'slas-summary-widget',
                'width'     => 6,
                'height'    => 12
            ];
            */
        }

        return $widgets;
    }

}
