<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.

declare(strict_types=1);

namespace SLAModule\Model\Entity;

use Cake\I18n\FrozenTime;
use Cake\ORM\Entity;

/**
 * HostMappingRule Entity
 *
 * @property int $id
 * @property int $sla_id
 * @property string|null $host_keywords
 * @property string|null $host_not_keywords
 * @property string|null $hostname_regex
 * @property string|null $description
 * @property int|null $only_unassigned
 * @property FrozenTime $created
 * @property FrozenTime $modified
 *
 * @property \SLAModule\Model\Entity\Sla $sla
 */
class HostMappingRule extends Entity {
    /**
     * Fields that can be mass assigned using newEntity() or patchEntity().
     *
     * Note that when '*' is set to true, this allows all unspecified fields to
     * be mass assigned. For security purposes, it is advised to set '*' to false
     * (or remove it), and explicitly make individual fields accessible as needed.
     *
     * @var array<string, bool>
     */
    protected $_accessible = [
        'sla_id'            => true,
        'host_keywords'     => true,
        'host_not_keywords' => true,
        'hostname_regex'    => true,
        'description'       => true,
        'only_unassigned'   => true,
        'created'           => true,
        'modified'          => true,
        'sla'               => true,
    ];
}
