<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.

declare(strict_types=1);

namespace SLAModule\Model\Entity;

use App\Model\Entity\Container;
use App\Model\Entity\Timeperiod;
use Cake\I18n\FrozenTime;
use Cake\ORM\Entity;

/**
 * Sla Entity
 *
 * @property int $id
 * @property string $name
 * @property string|null $description
 * @property int $container_id
 * @property int $timeperiod_id
 * @property float $minimal_availability
 * @property float|null $warning_threshold
 * @property FrozenTime $created
 * @property FrozenTime $modified
 *
 * @property Container $container
 * @property Timeperiod $timeperiod
 */
class Sla extends Entity {
    /**
     * Fields that can be mass assigned using newEntity() or patchEntity().
     *
     * Note that when '*' is set to true, this allows all unspecified fields to
     * be mass assigned. For security purposes, it is advised to set '*' to false
     * (or remove it), and explicitly make individual fields accessible as needed.
     *
     * @var array<string, bool>
     */
    protected $_accessible = [
        'name'                 => true,
        'description'          => true,
        'container_id'         => true,
        'timeperiod_id'        => true,
        'minimal_availability' => true,
        'warning_threshold'    => true,
        'start_date'           => true,
        'evaluation_interval'  => true,
        'consider_downtimes'   => true,
        'hard_state_only'      => true,
        'created'              => true,
        'modified'             => true,
        'container'            => true,
        'timeperiod'           => true,
        'hosttemplates'        => true,
        'hosts'                => true
    ];
}
