<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.

declare(strict_types=1);

namespace SLAModule\Model\Entity;

use App\Model\Entity\Host;
use Cake\I18n\FrozenTime;
use Cake\ORM\Entity;

/**
 * SlaAvailabilityStatusHost Entity
 *
 * @property int $id
 * @property int $host_id
 * @property int $sla_id
 * @property int $evaluation_total_time
 * @property int $total_time
 * @property float $minimal_availability_percent
 * @property float $determined_availability_percent
 * @property float $lowest_determined_availability_of_services_percent
 * @property int $minimal_availability_time
 * @property int $determined_availability_time
 * @property int $determined_outage_time
 * @property int $determined_number_outages
 * @property int $up
 * @property int $down
 * @property int $unreachable
 * @property FrozenTime $evaluation_start
 * @property FrozenTime $evaluation_end
 * @property FrozenTime $created
 * @property FrozenTime $updated
 *
 * @property Sla $sla
 * @property Host $host
 */
class SlaAvailabilityStatusHost extends Entity {
    /**
     * Fields that can be mass assigned using newEntity() or patchEntity().
     *
     * Note that when '*' is set to true, this allows all unspecified fields to
     * be mass assigned. For security purposes, it is advised to set '*' to false
     * (or remove it), and explicitly make individual fields accessible as needed.
     *
     * @var array<string, bool>
     */
    protected $_accessible = [
        'host_id'                                            => true,
        'sla_id'                                             => true,
        'evaluation_total_time'                              => true,
        'total_time'                                         => true,
        'minimal_availability_percent'                       => true,
        'determined_availability_percent'                    => true,
        'lowest_determined_availability_of_services_percent' => true,
        'minimal_availability_time'                          => true,
        'determined_availability_time'                       => true,
        'determined_outage_time'                             => true,
        'determined_number_outages'                          => true,
        'up'                                                 => true,
        'down'                                               => true,
        'unreachable'                                        => true,
        'evaluation_start'                                   => true,
        'evaluation_end'                                     => true,
        'created'                                            => true,
        'updated'                                            => true,
        'sla'                                                => true,
        'host'                                               => true,
        'sla_availability_status_services'                   => true
    ];
}
