<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.


declare(strict_types=1);

namespace SLAModule\Model\Entity;

use App\Model\Entity\Host;
use App\Model\Entity\Service;
use Cake\I18n\FrozenTime;
use Cake\ORM\Entity;

/**
 * SlaAvailabilityStatusServiceLog Entity
 *
 * @property int $id
 * @property int $host_id
 * @property int $service_id
 * @property int $sla_id
 * @property int $evaluation_total_time
 * @property int $total_time
 * @property float $minimal_availability_percent
 * @property float $determined_availability_percent
 * @property int $minimal_availability_time
 * @property int $determined_availability_time
 * @property int $determined_outage_time
 * @property int $determined_number_outages
 * @property int $ok
 * @property int $warning
 * @property int $critical
 * @property int $unknown
 * @property FrozenTime $evaluation_start
 * @property FrozenTime $evaluation_end
 * @property FrozenTime $created
 *
 * @property Host $host
 * @property Service $service
 * @property Sla $sla
 */
class SlaAvailabilityStatusServiceLog extends Entity {
    /**
     * Fields that can be mass assigned using newEntity() or patchEntity().
     *
     * Note that when '*' is set to true, this allows all unspecified fields to
     * be mass assigned. For security purposes, it is advised to set '*' to false
     * (or remove it), and explicitly make individual fields accessible as needed.
     *
     * @var array<string, bool>
     */
    protected $_accessible = [
        'host_id'                         => true,
        'service_id'                      => true,
        'sla_id'                          => true,
        'evaluation_total_time'           => true,
        'total_time'                      => true,
        'minimal_availability_percent'    => true,
        'determined_availability_percent' => true,
        'minimal_availability_time'       => true,
        'determined_availability_time'    => true,
        'determined_outage_time'          => true,
        'determined_number_outages'       => true,
        'ok'                              => true,
        'warning'                         => true,
        'critical'                        => true,
        'unknown'                         => true,
        'evaluation_start'                => true,
        'evaluation_end'                  => true,
        'created'                         => true,
        'host'                            => true,
        'service'                         => true,
        'sla'                             => true,
    ];
}
