<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.

?>

<ol class="breadcrumb page-breadcrumb">
    <li class="breadcrumb-item">
        <a ui-sref="DashboardsIndex">
            <i class="fa fa-home"></i> <?= __('Home'); ?>
        </a>
    </li>
    <li class="breadcrumb-item">
        <i class="fas fa-puzzle-piece"></i> <?= __(' Service Level Agreement Module'); ?>
    </li>
    <li class="breadcrumb-item">
        <a ui-sref="SlasIndex">
            <i class="fa-solid fa-award"></i> <?php echo __('Service Level Agreements'); ?>
        </a>
    </li>
    <li class="breadcrumb-item">
        <i class="fa fa-pencil"></i> <?= __('Manage mapping rules'); ?>
    </li>
</ol>


<div class="row">
    <div class="col-xl-12">
        <div id="panel-1" class="panel">
            <div class="panel-hdr">
                <h2>
                    <?php echo __('Host mapping rules'); ?>
                </h2>
                <div class="panel-toolbar">
                    <?php if ($this->Acl->hasPermission('index', 'Slas', 'SLAModule')): ?>
                        <a back-button href="javascript:void(0);" fallback-state='SlasIndex'
                           class="btn btn-default btn-xs mr-1 shadow-0">
                            <i class="fas fa-long-arrow-alt-left"></i> <?php echo __('Back'); ?>
                        </a>
                    <?php endif; ?>
                </div>
            </div>
            <div class="panel-hdr">
                <div class="alert border-primary bg-transparent fade show w-100 margin-10" role="alert">
                    <div class="d-flex align-items-center">
                        <div class="alert-icon">
                            <span class="icon-stack fa-3x">
                                <i class="base-2 icon-stack-3x color-primary-600"></i>
                                <i class="base-3 icon-stack-2x color-primary-700"></i>
                                <i class="ni ni-badge icon-stack-1x text-white"></i>
                            </span>
                        </div>
                        <div class="flex-1">
                            <span class="h4 text-primary">
                                <?= __('Service level Agreement: '); ?>
                                <?php if ($this->Acl->hasPermission('edit', 'Slas', 'SLAModule')): ?>
                                    <a ui-sref="SlasEdit({id: sla.id})"
                                       ng-if="sla.allowEdit">
                                            "{{ sla.name }}"
                                        </a>
                                <?php else: ?>
                                    "{{ sla.name }}"
                                <?php endif; ?>
                            </span>
                            <br>
                            <?= __('Please note: This in an one-time assignment. Hosts that will be created later on, are not automatically assigned to the given SLA. You would need to execute the rule manually to add new hosts.'); ?>
                            <br>
                            <?= __('It is recommended to assign the SLA via the host templates.'); ?>
                        </div>
                    </div>
                </div>
            </div>
            <div class="panel-container show">
                <div class="panel-content fuelux">
                    <form ng-submit="submit();" class="form-horizontal"
                          ng-init="successMessage=
                        {objectName : '<?php echo __('Host mapping rule'); ?>' , message:
                        '<?= __('created successfully'); ?>'}">

                        <fieldset class="margin-top-10">
                            <legend class="fieldset-legend-border-bottom">
                                <h5>
                                    <i class="fa-solid fa-display"></i>
                                    <?= __('Host'); ?>
                                </h5>
                            </legend>
                            <div class="form-group" ng-class="{'is-invalid': errors.host_keywords}">
                                <label class="control-label">
                                    <?= __('Included tags'); ?>
                                </label>
                                <div class="input-group">
                                    <div class="input-group-prepend">
                                        <span class="input-group-text">
                                            <i class="fa-solid fa-tags opacity-100 text-success cornered cornered-lr"></i>
                                        </span>
                                    </div>
                                    <div class="col-lg padding-left-0 padding-right-23">
                                        <input class="form-control tagsinput"
                                               data-role="tagsinput"
                                               type="text"
                                               id="HostTagsInput"
                                               ng-model="post.host_keywords">
                                    </div>
                                </div>
                                <div ng-repeat="error in errors.host_keywords">
                                    <div class="help-block text-danger">{{ error }}</div>
                                </div>
                                <div class="help-block">
                                    <?= __('Press return to separate tags'); ?>
                                </div>
                            </div>
                            <div class="form-group" ng-class="{'has-error': errors.host_not_keywords}">
                                <label class="control-label">
                                    <?= __('Excluded tags'); ?>
                                </label>
                                <div class="input-group">
                                    <div class="input-group-prepend">
                                        <span class="input-group-text">
                                            <i class="fa-solid fa-tags opacity-100 text-danger cornered cornered-lr"></i>
                                        </span>
                                    </div>
                                    <div class="col-lg padding-left-0 padding-right-23">
                                        <input class="form-control tagsinput"
                                               data-role="tagsinput"
                                               type="text"
                                               id="HostExcludedTagsInput"
                                               ng-model="post.host_not_keywords">
                                    </div>
                                </div>
                                <div ng-repeat="error in errors.host_not_keywords">
                                    <div class="help-block text-danger">{{ error }}</div>
                                </div>
                                <div class="help-block">
                                    <?= __('Press return to separate tags'); ?>
                                </div>
                            </div>

                            <div class="form-group">
                                <label class="control-label">
                                    <?= __('Host RegEx'); ?>
                                </label>
                                <div class="input-group">
                                    <div class="input-group-prepend">
                                        <span class="input-group-text">
                                           <regex-helper-tooltip></regex-helper-tooltip>
                                        </span>
                                    </div>
                                    <input class="form-control"
                                           type="text"
                                           ng-model="post.hostname_regex">
                                </div>
                                <div ng-repeat="error in errors.hostname_regex">
                                    <div class="help-block text-danger">{{ error }}</div>
                                </div>
                            </div>

                            <div class="form-group">
                                <label class="control-label">
                                    <?= __('Host description'); ?>
                                </label>
                                <div class="input-group">
                                    <div class="input-group-prepend">
                                        <span class="input-group-text">
                                            <i class="fa-solid fa-filter"></i>
                                        </span>
                                    </div>
                                    <input class="form-control"
                                           type="text"
                                           ng-model="post.description">
                                </div>
                            </div>

                            <div class="form-group margin-top-20">
                                <div class="custom-control custom-checkbox">
                                    <input type="checkbox"
                                           id="OnlyUnassigned"
                                           name="checkbox"
                                           class="custom-control-input"
                                           ng-model="post.only_unassigned">
                                    <label class="custom-control-label"
                                           for="OnlyUnassigned"><?= __('Only unassigned hosts'); ?></label>
                                </div>
                            </div>

                        </fieldset>
                        <div class="col-12 no-padding">
                            <div class="alert border-faded bg-transparent text-secondary margin-top-20">
                                <div class="d-flex align-items-center">
                                    <div class="alert-icon">
                                                            <span class="icon-stack icon-stack-md">
                                                                <i class="base-7 icon-stack-3x color-primary-600"></i>
                                                                <i class="fas fa-info icon-stack-1x text-white"></i>
                                                            </span>
                                    </div>
                                    <div class="flex-1">
                                        <span class="h5 color-primary-600">
                                            <?= __('Show affected hosts'); ?>
                                        </span>
                                        <br>
                                        <?= __('This list is only for previewing which hosts will be updated.'); ?>
                                    </div>
                                    <button class="btn btn-outline-primary btn-sm btn-w-m waves-effect waves-themed"
                                            ng-click="loadHosts()"
                                            type="button">
                                                    <span>
                                                        <i class="fa fa-spinner fa-spin"
                                                           ng-show="loadHostsSpinner"></i>
                                                    </span>
                                        <?= __('Load hosts by mapping rules'); ?>
                                    </button>
                                </div>
                            </div>
                            <table class="table table-striped m-0 table-bordered table-hover table-sm" ng-if="hosts">
                                <thead>
                                <tr>
                                    <th class="no-sort" ng-click="orderBy('Hosts.name')">
                                        <i class="fa" ng-class="getSortClass('Hosts.name')"></i>
                                        <?= __('Name'); ?>
                                    </th>

                                    <th class="no-sort" ng-click="orderBy('Hosts.address')">
                                        <i class="fa" ng-class="getSortClass('Hosts.address')"></i>
                                        <?= __('Address'); ?>
                                    </th>

                                    <th class="no-sort" ng-click="orderBy('hostdescription')">
                                        <i class="fa" ng-class="getSortClass('hostdescription')"></i>
                                        <?= __('Description'); ?>
                                    </th>

                                    <th class="no-sort">
                                        <?= __('Tags'); ?>
                                    </th>

                                    <th class="no-sort">
                                        <?= __('Container'); ?>
                                    </th>
                                    <th class="no-sort">
                                        <?= __('SLA'); ?>
                                    </th>
                                </tr>
                                </thead>
                                <tbody>
                                <tr ng-repeat="host in hosts">
                                    <td>
                                        <?php if ($this->Acl->hasPermission('browser', 'hosts')): ?>
                                            <a ui-sref="HostsBrowser({id:host.id})">
                                                {{host.name}}
                                            </a>
                                        <?php else: ?>
                                            {{host.name}}
                                        <?php endif; ?>
                                    </td>
                                    <td>
                                        {{host.address}}
                                    </td>
                                    <td>
                                        {{host.hostdescription}}
                                    </td>
                                    <td>
                                        <span class="badge badge-primary mr-1" ng-show="host.hosttags"
                                              ng-repeat="tag in host.hosttags.split(',')">
                                            {{tag}}
                                        </span>
                                    </td>
                                    <td>
                                        {{host.primary_container}}
                                    </td>
                                    <td>
                                        <i class="fa-solid fa-minus text-danger" ng-show="host.sla === null"></i>
                                        <?php if ($this->Acl->hasPermission('edit', 'Slas', 'SLAModule')): ?>
                                            <a ui-sref="SlasEdit({id: host.sla.id})" ng-if="sla.allowEdit">
                                                {{host.sla.name}}
                                            </a>
                                            <span ng-hide="sla.allowEdit">
                                            {{host.sla.name}}
                                        </span>
                                        <?php endif; ?>
                                    </td>
                                </tr>

                                </tbody>
                            </table>
                            <div ng-if="hosts">
                                <scroll scroll="scroll" click-action="changepage" ng-if="scroll"></scroll>
                                <paginator paging="paging" click-action="changepage" ng-if="paging"></paginator>
                                <?php echo $this->element('paginator_or_scroll'); ?>
                            </div>

                        </div>

                        <div class="card margin-top-10">
                            <div class="card-body">
                                <div class="float-right">
                                    <div class="btn-group">
                                        <?php if ($this->Acl->hasPermission('assignToHosts', 'HostMappingRules', 'SLAModule')): ?>
                                            <button type="submit" class="btn btn-primary waves-effect waves-themed">
                                                <?= __('Assign to hosts'); ?>
                                            </button>
                                            <button type="button"
                                                    class="btn btn-primary dropdown-toggle dropdown-toggle-split waves-effect waves-themed"
                                                    data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                                            <span class="sr-only">
                                                Toggle Dropdown
                                            </span>
                                            </button>
                                            <div class="dropdown-menu dropdown-menu-right">
                                                <a class="dropdown-item" href="javascript:void(0);"
                                                   ng-click="submit(true)">
                                                    <?= __('Save mapping rule and assign to hosts'); ?>
                                                </a>
                                            </div>
                                        <?php endif; ?>
                                    </div>
                                    <a back-button href="javascript:void(0);"
                                       fallback-state='SlasIndex'
                                       class="btn btn-default"><?php echo __('Cancel'); ?>
                                    </a>
                                </div>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>
