<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.

?>
<ol class="breadcrumb page-breadcrumb">
    <li class="breadcrumb-item">
        <a ui-sref="DashboardsIndex">
            <i class="fa fa-home"></i> <?= __('Home'); ?>
        </a>
    </li>
    <li class="breadcrumb-item">
        <i class="fas fa-puzzle-piece"></i> <?= __('Service Level Agreement Module'); ?>
    </li>
    <li class="breadcrumb-item">
        <a ui-sref="SlasIndex">
            <i class="fa-solid fa-award"></i> <?php echo __('Service Level Agreements'); ?>
        </a>
    </li>
    <li class="breadcrumb-item">
        <i class="fa-solid fa-list-check"></i> <?= __('SLA Host Overview'); ?>
    </li>
</ol>

<div class="row">
    <div class="col-xl-12">
        <div id="panel-1" class="panel">
            <div class="panel-hdr">
                <h2>
                    <?= __('SLA Host Status Log'); ?>
                    <span class="fw-300"><i><?= __('overview'); ?></i></span>

                </h2>
                <div class="panel-toolbar">
                    <button class="btn btn-xs btn-default mr-1 shadow-0" ng-click="load()">
                        <i class="fas fa-sync"></i> <?= __('Refresh'); ?>
                    </button>
                    <button class="btn btn-xs btn-primary shadow-0" ng-click="triggerFilter()">
                        <i class="fas fa-filter"></i> <?= __('Filter'); ?>
                    </button>
                </div>
            </div>
            <div class="panel-container show">
                <div class="panel-content">
                    <span class="padding-left-10 font-md">
                        <i class="fa fa-desktop fa-fw"></i>
                        <?php if ($this->Acl->hasPermission('browser', 'hosts')): ?>
                            <a ui-sref="HostsBrowser({id:host.id})">{{ host.name }}</a>
                        (
                        <span class="copy-to-clipboard-container-text">
                            {{ host.address }}
                            <span ng-click="rootCopyToClipboard(host.address, $event)"
                                  class="copy-action text-primary animated"
                                  data-copied="<?= __('Copied'); ?>"
                                  data-copy="<?= __('Copy'); ?>">
                                <?= __('Copy'); ?>
                            </span>
                        </span>
                            )
                        <?php else: ?>
                            {{ host.name }} ({{ host.address }})
                        <?php endif; ?>
                    </span>
                    <!-- Start Filter -->
                    <div class="list-filter card margin-bottom-10" ng-show="showFilter">
                        <div class="card-header">
                            <i class="fa fa-filter"></i> <?= __('Filter'); ?>
                        </div>
                        <div class="card-body">
                            <div class="card-body">
                                <div class="row">
                                    <div class="col-xs-12 col-md-6 margin-bottom-10">
                                        <div class="form-group">
                                            <div class="input-group">
                                                <div class="input-group-prepend">
                                                <span
                                                        class="input-group-text filter-text"><?= __('From'); ?></span>
                                                </div>
                                                <input type="datetime-local" class="form-control form-control-sm"
                                                       style="padding:0.5rem 0.875rem;"
                                                       placeholder="<?= __('From date'); ?>"
                                                       ng-model="from_time"
                                                       ng-model-options="{debounce: 500, timeSecondsFormat:'ss', timeStripZeroSeconds: true}">
                                            </div>
                                        </div>
                                    </div>

                                    <div class="col-xs-12 col-md-6 margin-bottom-10">
                                        <div class="form-group">
                                            <div class="input-group">
                                                <div class="input-group-prepend">
                                                <span
                                                        class="input-group-text filter-text"><?php echo __('To'); ?></span>
                                                </div>
                                                <input type="datetime-local" class="form-control form-control-sm"
                                                       style="padding:0.5rem 0.875rem;"
                                                       placeholder="<?= __('To date'); ?>"
                                                       ng-model="to_time"
                                                       ng-model-options="{debounce: 500, timeSecondsFormat:'ss', timeStripZeroSeconds: true}">
                                            </div>
                                        </div>
                                    </div>
                                </div>
                                <div class="float-right">
                                    <button type="button" ng-click="resetFilter()"
                                            class="btn btn-xs btn-danger">
                                        <?php echo __('Reset Filter'); ?>
                                    </button>
                                </div>
                            </div>
                        </div>
                    </div>
                    <!-- End Filter -->

                    <div class="frame-wrap">
                        <div class="col-lg-12 padding-10">
                            <table class="table table-bordered table-sm table-striped">
                                <thead>
                                <tr>
                                    <th>
                                        <?= __('Evaluation range'); ?>
                                    </th>
                                    <th class="col-2">
                                        <?= __('State summary'); ?>
                                    </th>
                                    <th class="col-5">
                                    <?= __('Outage overview'); ?>
                                    </th>
                                    <th>
                                        <?= __('Goal'); ?>(%)
                                    </th>
                                    <th>
                                        <?= __(' Achieved'); ?>(%)
                                    </th>
                                    <th colspan="2">
                                        <?= __('Status'); ?>
                                    </th>
                                </tr>
                                </thead>
                                <tbody>
                                <tr ng-repeat="hostStatus in slaHostStatusLog" class="pl-1">
                                    <td>
                                        <ul class="evaluation-range timeline">
                                            <li class="m-1 pl-1 start">
                                                {{hostStatus.start}}
                                            </li>
                                            <li class="m-1 pl-1 end">
                                                {{hostStatus.end}}
                                            </li>
                                        </ul>
                                    </td>
                                    <td>
                                        <div class="btn-group btn-group-justified w-100">
                                            <label class="badge badge-success col-4 rounded-left-only">
                                                {{hostStatus.up_human_readable}}
                                            </label>
                                            <label class="badge badge-danger col-4 rounded-0">
                                                {{hostStatus.down_human_readable}}
                                            </label>
                                            <label class="badge badge-secondary col-4 rounded-right-only">
                                                {{hostStatus.unreachable_human_readable}}
                                            </label>
                                        </div>
                                    </td>
                                    <td>
                                        <i class="fa-solid fa-clock text-primary"></i>
                                        {{hostStatus.determined_outage_time_human_readable}}

                                        <ul class="list-unstyled p-2"
                                            ng-if="hostStatus.sla_host_outages.length > 0">
                                            <div class="border-primary border-bottom pb-1">
                                                <?= __('Outages'); ?>
                                            </div>
                                            <li ng-repeat="outage in hostStatus.sla_host_outages|filter:{in_downtime:false}"
                                                class="padding-left-15 pb-2">
                                                <i class="fa-solid fa-bolt text-danger"></i>
                                                {{outage.start}}
                                                <i class="fa-solid fa-minus text-primary"></i>
                                                {{outage.end}} ({{outage.duration}})
                                                <br/>
                                                <code>
                                                    {{outage.output}}
                                                </code>
                                            </li>
                                            <li ng-repeat="outage in hostStatus.sla_host_outages|filter:{in_downtime:true}"
                                                class="padding-left-15 cursor-help" title="<?= __('In downtime'); ?>">
                                                <i class="fa-solid fa-power-off text-primary"></i>
                                                {{outage.start}}
                                                <i class="fa-solid fa-minus text-primary"></i>
                                                {{outage.end}}
                                                (<span class="outages-in-downtime ">{{outage.duration}}</span>)
                                                <br/>
                                                <code>
                                                    {{outage.output}}
                                                </code>
                                            </li>
                                        </ul>
                                    </td>
                                    <td>
                                        {{hostStatus.minimal_availability_percent}}%
                                    </td>
                                    <td class="text-{{hostStatus.state}}">
                                        {{hostStatus.determined_availability_percent}}%
                                    </td>
                                    <td>
                                        <span class="badge border w-100 text-{{hostStatus.state}} border-{{hostStatus.state}}"
                                              ng-hide="hostStatus.state === 'danger'">
                                            <?= __('PASSED') ?>
                                        </span>
                                        <span class="badge border w-100 text-{{hostStatus.state}} border-{{hostStatus.state}}"
                                              ng-show="hostStatus.state === 'danger'">
                                            <?= __('FAILED') ?>
                                        </span>
                                    </td>
                                    <td>
                                        <span ng-if!="$last">
                                            <span ng-init="declineValue = slaHostStatusLog[$index+1].determined_availability_percent - hostStatus.determined_availability_percent">
                                                <span ng-show="declineValue > 0"
                                                      class="small color-danger-50">
                                                   <i class="fa-solid fa-caret-down"></i> {{declineValue | number: 2}}%
                                                </span>
                                            </span>
                                        </span>
                                    </td>
                                </tr>
                                </tbody>
                            </table>
                        </div>
                        <div class="margin-top-10" ng-show="slaHostStatusLog.length == 0">
                            <div class="text-center text-danger italic">
                                <?php echo __('No entries match the selection'); ?>
                            </div>
                        </div>

                        <scroll scroll="scroll" click-action="changepage" ng-if="scroll"></scroll>
                        <paginator paging="paging" click-action="changepage" ng-if="paging"></paginator>
                        <?php echo $this->element('paginator_or_scroll'); ?>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
