<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.

?>

<ol class="breadcrumb page-breadcrumb">
    <li class="breadcrumb-item">
        <a ui-sref="DashboardsIndex">
            <i class="fa fa-home"></i> <?= __('Home'); ?>
        </a>
    </li>
    <li class="breadcrumb-item">
        <i class="fas fa-puzzle-piece"></i> <?= __('Service Level Agreement Module'); ?>
    </li>
    <li class="breadcrumb-item">
        <a ui-sref="SlasIndex">
            <i class="fa-solid fa-award"></i> <?php echo __('Service Level Agreements'); ?>
        </a>
    </li>
    <li class="breadcrumb-item">
        <i class="fa fa-plus"></i> <?= __('Add SLA'); ?>
    </li>
</ol>


<div class="row">
    <div class="col-xl-12">
        <div id="panel-1" class="panel">
            <div class="panel-hdr">
                <h2>
                    <?= __('Create Service Level Agreement'); ?>
                </h2>
                <div class="panel-toolbar">
                    <?php if ($this->Acl->hasPermission('index', 'Slas', 'SLAModule')): ?>
                        <a back-button href="javascript:void(0);" fallback-state='SlasIndex'
                           class="btn btn-default btn-xs mr-1 shadow-0">
                            <i class="fas fa-long-arrow-alt-left"></i> <?php echo __('Back'); ?>
                        </a>
                    <?php endif; ?>
                </div>
            </div>
            <div class="panel-container show">
                <div class="panel-content fuelux">
                    <form ng-submit="submit();" class="form-horizontal"
                          ng-init="successMessage=
                        {objectName : '<?= __('SLA'); ?>' , message:
                        '<?= __('created successfully'); ?>'}">

                        <div class="form-group required" ng-class="{'has-error': errors.containers}">
                            <label class="control-label" for="SlasContainers">
                                <?php echo __('Container'); ?>
                            </label>
                            <select
                                    id="SlasContainers"
                                    data-placeholder="<?php echo __('Please choose'); ?>"
                                    class="form-control"
                                    chosen="containers"
                                    ng-options="container.key as container.value for container in containers"
                                    ng-model="post.container_id">
                            </select>
                            <div ng-show="post.container_id < 1" class="warning-glow">
                                <?php echo __('Please select a container.'); ?>
                            </div>
                            <div ng-repeat="error in errors.container_id">
                                <div class="help-block text-danger">{{ error }}</div>
                            </div>
                        </div>

                        <div class="form-group required" ng-class="{'has-error': errors.name}">
                            <label class="control-label">
                                <?= __('Name'); ?>
                            </label>
                            <input
                                    class="form-control"
                                    type="text"
                                    ng-model="post.name">
                            <div ng-repeat="error in errors.name">
                                <div class="help-block text-danger">{{ error }}</div>
                            </div>
                        </div>

                        <div class="form-group">
                            <label class="control-label">
                                <?php echo __('Description'); ?>
                            </label>
                            <input class="form-control"
                                   type="text"
                                   ng-model="post.description">
                        </div>

                        <div class="form-group required" ng-class="{'has-error': errors.evaluation_interval}">
                            <label class="control-label">
                                <?php echo __('Evaluation period'); ?>
                            </label>
                            <select class="form-control"
                                    ng-model="post.evaluation_interval"
                                    chosen="{}">
                                <option value="YEAR"><?php echo __('Year'); ?></option>
                                <option value="QUARTER"><?php echo __('Quarter'); ?></option>
                                <option value="MONTH"><?php echo __('Month'); ?></option>
                                <option value="WEEK"><?php echo __('Week'); ?></option>
                                <option value="DAY"><?php echo __('Day'); ?></option>
                            </select>
                            <div ng-repeat="error in errors.evaluation_interval">
                                <div class="help-block text-danger">{{ error }}</div>
                            </div>
                        </div>

                        <div class="form-group" ng-class="{'has-error': errors.start_date}">
                            <label class="control-label">
                                <?php echo __('Start date'); ?>
                            </label>
                            <input type="date" class="form-control"
                                   placeholder="<?= __('Start date'); ?>"
                                   ng-model="post.start_date"
                                   ng-model-options="{debounce: 500, timeSecondsFormat:'ss', timeStripZeroSeconds: true}">
                            <div class="helptext help-block">
                                <?= __('If no start date is defined, 1. January of the current year will be used automatically.'); ?>
                            </div>
                            <div ng-repeat="error in errors.start_date">
                                <div class="help-block text-danger">{{ error }}</div>
                            </div>
                        </div>

                        <div class="form-group required" ng-class="{'has-error': errors.minimal_availability}">
                            <label class="control-label">
                                <?= __('Guaranteed availability as percentage'); ?>
                            </label>
                            <div class="input-group">
                                <input class="form-control"
                                       type="text"
                                       placeholder="0-100"
                                       ng-model="post.minimal_availability">
                                <div class="input-group-append">
                                     <span class="input-group-text bg-success text-white">
                                        <i class="fa-solid fa-check"></i>
                                     </span>
                                </div>
                            </div>
                            <div class="helptext help-block">
                                <?= __('An uptime guarantee that indicates the percentage of time the system is available'); ?>
                            </div>
                            <div ng-repeat="error in errors.minimal_availability">
                                <div class="help-block text-danger">{{ error }}</div>
                            </div>
                        </div>

                        <div class="form-group">
                            <?= __('Warning threshold as percentage'); ?>
                            <div class="input-group">
                                <input class="form-control"
                                       type="text"
                                       placeholder="0-100"
                                       ng-model="post.warning_threshold">
                                <div class="input-group-append">
                                    <span class="input-group-text bg-warning text-white">
                                        <i class="fa-solid fa-bell"></i>
                                    </span>
                                </div>
                            </div>
                            <div ng-repeat="error in errors.warning_threshold">
                                <div class="help-block text-danger">{{ error }}</div>
                            </div>
                        </div>

                        <div class="form-group required" ng-class="{'has-error': errors.timeperiod_id}">
                            <label class="control-label" for="SlaTimeperiod">
                                <?php if ($this->Acl->hasPermission('edit', 'timeperiods')): ?>
                                    <a ui-sref="TimeperiodsEdit({id:post.timeperiod_id})"
                                       ng-if="post.timeperiod_id > 0">
                                        <?= __('Operating time'); ?>
                                    </a>
                                    <span ng-if="!post.timeperiod_id"><?= __('Operating time'); ?></span>
                                <?php else: ?>
                                    <?php echo __('Operating time'); ?>
                                <?php endif; ?>
                            </label>
                            <div class="input-group">
                                <select
                                        id="SlaTimeperiod"
                                        data-placeholder="<?php echo __('Please choose'); ?>"
                                        class="form-control"
                                        chosen="timeperiods"
                                        ng-options="timeperiod.key as timeperiod.value for timeperiod in timeperiods"
                                        ng-model="post.timeperiod_id">
                                </select>
                                <div class="input-group-append">
                                    <span class="input-group-text">
                                         <?php if ($this->Acl->hasPermission('viewDetails', 'timeperiods')): ?>
                                             <timeperiod-details-tooltip timeperiod-id="post.timeperiod_id"
                                                                         ng-if="post.timeperiod_id != null">
                                             </timeperiod-details-tooltip>
                                             <i class="fa-regular fa-clock" ng-hide="post.timeperiod_id > 0"></i>
                                         <?php else: ?>
                                             <i class="fa-regular fa-clock"></i>
                                         <?php endif; ?>
                                    </span>
                                </div>
                            </div>
                            <div ng-repeat="error in errors.timeperiod_id">
                                <div class="help-block text-danger">{{ error }}</div>
                            </div>
                        </div>
                        <div class="form-group margin-top-20">
                            <div class="custom-control custom-checkbox">
                                <input type="checkbox"
                                       id="ConsiderDowntimes"
                                       ng-false-value="0"
                                       ng-true-value="1"
                                       name="checkbox"
                                       class="custom-control-input"
                                       ng-model="post.consider_downtimes">
                                <label class="custom-control-label"
                                       for="ConsiderDowntimes"><?= __('Consider downtimes'); ?></label>
                            </div>
                        </div>

                        <div class="form-group">
                            <label class="control-label">
                                <?php echo __('Reflection state'); ?>
                            </label>
                            <select class="form-control"
                                    ng-model="post.hard_state_only"
                                    chosen="{}">
                                <option ng-value="0"><?php echo __('soft and hard state'); ?></option>
                                <option ng-value="1"><?php echo __('only hard state'); ?></option>
                            </select>
                        </div>

                        <div class="card margin-top-10">
                            <div class="card-body">
                                <div class="float-right">
                                    <div class="btn-group">
                                        <button type="submit" class="btn btn-primary waves-effect waves-themed">
                                            <?php echo __('Save SLA'); ?>
                                        </button>
                                        <?php if ($this->Acl->hasPermission('assignToHosts', 'HostMappingRules', 'SLAModule')): ?>
                                            <button type="button"
                                                    class="btn btn-primary dropdown-toggle dropdown-toggle-split waves-effect waves-themed"
                                                    data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                                            <span class="sr-only">
                                                Toggle Dropdown
                                            </span>
                                            </button>
                                            <div class="dropdown-menu dropdown-menu-right">
                                                <a class="dropdown-item" href="javascript:void(0);"
                                                   ng-click="submit('HostMappingRules')">
                                                    <div class="icon-stack">
                                                        <i class="fas fa-desktop opacity-100 "></i>
                                                        <i class="fa-solid fa-plus opacity-100 fa-xs text-success cornered cornered-lr"></i>
                                                    </div>
                                                    <?php echo __('Save and go to host assignments'); ?>
                                                </a>
                                            </div>
                                        <?php endif; ?>
                                    </div>
                                    <a back-button href="javascript:void(0);"
                                       fallback-state='SlasIndex'
                                       class="btn btn-default"><?php echo __('Cancel'); ?>
                                    </a>
                                </div>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>
