<?php
// Copyright (C) <2017>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.

$Logo = new \itnovum\openITCOCKPIT\Core\Views\Logo();

?>
<ol class="breadcrumb page-breadcrumb">
    <li class="breadcrumb-item">
        <a ui-sref="DashboardsIndex">
            <i class="fa fa-home"></i> <?= __('Home'); ?>
        </a>
    </li>
    <li class="breadcrumb-item">
        <i class="fas fa-puzzle-piece"></i> <?= __('Service Level Agreement Module'); ?>
    </li>
    <li class="breadcrumb-item">
        <a ui-sref="SlasIndex">
            <i class="fa-solid fa-award"></i> <?php echo __('Service Level Agreements'); ?>
        </a>
    </li>
    <li class="breadcrumb-item">
        <i class="fa fa-list"></i> <?php echo __('Generate Report'); ?>
    </li>
</ol>

<div class="row">
    <div class="col-xl-12">
        <div id="panel-1" class="panel">
            <div class="panel-hdr">
                <h2 ng-if="!reportWasGenerated">
                    <?php echo __('Generate sla report'); ?>
                </h2>
                <h2 ng-if="reportWasGenerated">
                    {{sla.name}}
                    <span class="fw-300">
                        <i>{{report.evaluation_time.start_human}}</i>
                        -
                        <i>{{report.evaluation_time.end_human}}</i>
                    </span>
                </h2>
                <?php if ($this->Acl->hasPermission('index', 'slas', 'SLAModule')): ?>
                    <div class="panel-toolbar padding-right-5">
                        <a back-button href="javascript:void(0);" fallback-state='SlasIndex'
                           class="btn btn-default btn-xs mr-1 shadow-0">
                            <i class="fas fa-long-arrow-alt-left"></i> <?php echo __('Back'); ?>
                        </a>
                    </div>
                <?php endif; ?>
                <div class="panel-toolbar">
                    <ul class="nav nav-tabs border-bottom-0 nav-tabs-clean" role="tablist">
                        <li class="nav-item">
                            <a class="nav-link active" data-toggle="tab" ng-class="{'active': tabName=='reportConfig'}"
                               ng-click="tabName='reportConfig'"
                               role="tab">
                                <i class="fa fa-pencil-square-o"></i>
                            </a>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link" data-toggle="tab"
                               ng-class="{'active': tabName=='showReport'}"
                               ng-click="tabName='showReport'"
                               ng-show="reportWasGenerated"
                               role="tab">
                                <i class="fa fa-pie-chart"></i>
                            </a>
                        </li>
                    </ul>
                </div>
            </div>
            <div class="panel-container show">
                <div class="panel-content">
                    <div ng-show="tabName == 'reportConfig'">
                        <div class="alert alert-danger" role="alert" ng-show="report_error">
                            {{ report_error.message }}
                            <ul ng-show="report_error.objects">
                                <li ng-repeat="host in report_error.objects">
                                    {{host.name}}

                                    <ul ng-show="host.services">
                                        <li ng-repeat="service in host.services">
                                            {{service}}
                                        </li>
                                    </ul>
                                </li>
                            </ul>
                        </div>

                        <form ng-submit="submit();" class="form-horizontal"
                              ng-init="reportMessage={successMessage : '<?php echo __('Report created successfully'); ?>' , errorMessage: '<?php echo __('Report could not be created'); ?>'}">
                            <div class="form-group required">
                                <label class="col col-2 control-label">
                                    <?php echo __('SLA'); ?>
                                </label>
                                <div class="col col-12">
                                    <select
                                            id="ReportId"
                                            data-placeholder="<?php echo __('Please choose'); ?>"
                                            class="form-control"
                                            chosen="slas"
                                            ng-options="sla.id as sla.name for sla in slas"
                                            ng-model="post.Sla.id">
                                    </select>
                                </div>
                            </div>

                            <div class="form-group required">
                                <label class="col col-2 control-label">
                                    <?php echo __('Report format'); ?>
                                </label>
                                <div class="col col-12">
                                    <select
                                            id="SlaFormat"
                                            data-placeholder="<?php echo __('Please choose'); ?>"
                                            class="form-control"
                                            chosen="{}"
                                            ng-model="post.Sla.format">
                                        <option value="pdf"><?php echo __('PDF'); ?></option>
                                        <option value="html"><?php echo __('HTML'); ?></option>
                                        <option value="zip"><?php echo __('CSV'); ?></option>
                                    </select>
                                </div>
                            </div>

                            <div class="form-group required" ng-class="{'has-error': errors.evaluation}">
                                <label class="col col-2 control-label">
                                    <?php echo __('Evaluation'); ?>
                                </label>
                                <div class="col col-12">
                                    <div class="custom-control custom-radio custom-control-inline">
                                        <input type="radio" class="custom-control-input"
                                               name="evaluationType"
                                               id="SlaEvaluation1"
                                               ng-model="post.Sla.evaluation"
                                               ng-value="1">
                                        <label class="custom-control-label" for="SlaEvaluation1">
                                            <i class="fa fa-desktop"></i> <?php echo __('Hosts'); ?>
                                        </label>
                                    </div>
                                    <div class="custom-control custom-radio custom-control-inline">
                                        <input type="radio" class="custom-control-input"
                                               name="evaluationType"
                                               id="SlaEvaluation2"
                                               ng-model="post.Sla.evaluation"
                                               ng-value="2">
                                        <label class="custom-control-label" for="SlaEvaluation2">
                                            <i class="fa fa-cogs"></i> <?php echo __('Hosts and Services'); ?>
                                        </label>
                                    </div>
                                    <div class="custom-control custom-radio custom-control-inline">
                                        <input type="radio" class="custom-control-input"
                                               name="evaluationType"
                                               id="SlaEvaluation3"
                                               ng-model="post.Sla.evaluation"
                                               ng-value="3">
                                        <label class="custom-control-label" for="SlaEvaluation3">
                                            <i class="fa fa-cog"></i> <?php echo __('Service'); ?>
                                        </label>
                                    </div>
                                    <div ng-repeat="error in errors.evaluation">
                                        <div class="help-block text-danger">{{ error }}</div>
                                    </div>
                                    <div class="col col-md-offset-2 col-md-10">
                                        <div class="help-block">
                                            <?php echo __('Choose if <b><u>only</u></b> host, host and services or <b><u>only</u></b> services should be evaluated.'); ?>
                                        </div>
                                    </div>
                                </div>
                            </div>
                            <div class="form-group" ng-class="{'has-error': errors.from_date}">
                                <label class="control-label">
                                    <?php echo __('From'); ?>
                                </label>
                                <input
                                        class="form-control"
                                        type="date"
                                        ng-model="from"
                                        placeholder="<?php echo __('DD.MM.YYYY'); ?>">
                                <div ng-repeat="error in errors.from_date">
                                    <div class="help-block text-danger">{{ error }}</div>
                                </div>
                            </div>

                            <div class="form-group" ng-class="{'has-error': errors.to_date}">
                                <label class="control-label">
                                    <?php echo __('To'); ?>
                                </label>
                                <input
                                        class="form-control"
                                        type="date"
                                        ng-model="to"
                                        placeholder="<?php echo __('DD.MM.YYYY'); ?>">
                                <div ng-repeat="error in errors.to_date">
                                    <div class="help-block text-danger">{{ error }}</div>
                                </div>
                            </div>
                            <div class="card margin-top-10">
                                <div class="card-body">
                                    <div class="float-right">
                                        <button class="btn btn-primary"
                                                ng-disabled="isGenerating"
                                                type="submit">
                                            <i class="fas fa-spinner fa-spin" ng-show="isGenerating"></i>
                                            <?php echo __('Generate report'); ?>
                                        </button>
                                    </div>
                                </div>
                            </div>

                        </form>
                    </div>

                    <div ng-show="tabName == 'showReport'">
                        <div class="row">
                            <div class="col-xs-12 col-md-6 col-lg-6">
                                <div class="row">
                                    <div class="col-xs-12 col-md-6 col-lg-4">
                                        <h4>
                                            <?= __('Evaluated time period'); ?>
                                        </h4>
                                    </div>

                                    <div class="col-xs-12 col-md-6 col-lg-8">
                                        <div class="row">
                                            <div class="col-12">
                                                <?php if ($this->Acl->hasPermission('edit', 'timeperiods')): ?>
                                                    <a ui-sref="TimeperiodsEdit({id: report.timeperiod.id})">
                                                        {{report.timeperiod.name}}
                                                    </a>
                                                <?php else: ?>
                                                    {{report.timeperiod.name}}
                                                <?php endif; ?>
                                            </div>
                                        </div>
                                        <div class="row"
                                             ng-repeat="timerange in report.timeperiod.timeperiod_timeranges">
                                            <div class="col-xs-12 col-md-6 col-lg-2">
                                                {{timerange.weekday}}
                                            </div>
                                            <div class="col-xs-12 col-md-6 col-lg-10">
                                                {{timerange.start}}
                                                -
                                                {{timerange.end}}
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>

                            <div class="col-xs-12 col-md-6 col-lg-6 text-right">
                                <img alt="logo" src="<?php echo $Logo->getLogoForHtml(); ?>" width="200">
                            </div>
                        </div>

                        <div class="row padding-top-10">
                            <div class="col-12">
                                <h4>
                                    <?= __('Host and service details') ?>
                                </h4>
                            </div>
                        </div>
                        <fieldset class="margin-top-20" ng-repeat="date_range in report.date_ranges">
                            <legend class="fieldset-legend-border-bottom">
                                <h5>
                                    <i class="fa-solid fa-calendar-days text-primary"></i>
                                    {{date_range.title}}
                                    <span class="font-xs italic pl-5">
                                        {{date_range.start_human}}
                                        <i class="fa-solid fa-minus  text-primary"></i>
                                        {{date_range.end_human}}
                                    </span>

                                </h5>
                            </legend>
                            <div ng-if="post.Sla.evaluation !== 3" class="mt-2">
                                <table class="table table-striped m-0 table-bordered table-hover table-sm">
                                    <thead>
                                    <tr>
                                        <th>
                                            <?= __('Host'); ?> / <?= __('Service'); ?>
                                        </th>
                                        <th>
                                            <?= __('Total time'); ?>
                                        </th>
                                        <th>
                                            <?= __('Uptime'); ?>
                                        </th>
                                        <th>
                                            <?= __('Outage time'); ?>
                                        </th>
                                        <th>
                                            <?= __('Outages'); ?>
                                        </th>
                                        <th>
                                            <?= __('Goal(%)'); ?>
                                        </th>
                                        <th>
                                            <?= __('Achieved(%)'); ?>
                                        </th>
                                        <th>
                                            <?= __('Status'); ?>
                                        </th>
                                    </tr>

                                    </thead>
                                    <tbody>
                                    <tr ng-repeat-start="host in report.hosts[$index]"
                                        ng-if="host.sla_log.last_log_entry.evaluation_total_time_human_readable">
                                        <td>
                                            <i class="fas fa-desktop"></i>
                                            {{host.host.name}}
                                        </td>
                                        <td>
                                            {{host.sla_log.last_log_entry.evaluation_total_time_human_readable}}
                                        </td>
                                        <td>
                                            {{host.sla_log.last_log_entry.determined_availability_time_human_readable}}
                                        </td>
                                        <td>
                                            {{host.sla_log.last_log_entry.determined_outage_time_human_readable}}
                                        </td>
                                        <td>
                                            <?php if ($this->Acl->hasPermission('index', 'SlaAvailabilityStatusHostsLog', 'SLAModule')): ?>
                                                <a ui-sref="SlaAvailabilityStatusHostsLog({id:host.host.id, from:date_range.start, to:date_range.end})"
                                                   ng-class="{'text-danger': host.sla_log.outages.length > 0}">
                                                    {{host.sla_log.outages.length}}
                                                </a>
                                            <?php else: ?>
                                                {{host.sla_log.outages.length}}
                                            <?php endif; ?>
                                        </td>
                                        <td>
                                            {{host.sla_log.last_log_entry.minimal_availability_percent}}%
                                        </td>
                                        <td ng-class="{'text-danger': !host.sla_log.last_log_entry.passed}">
                                            <?php if ($this->Acl->hasPermission('index', 'SlaAvailabilityStatusHostsLog', 'SLAModule')): ?>
                                                <a ui-sref="SlaAvailabilityStatusHostsLog({id:host.host.id, from:date_range.start, to:date_range.end})"
                                                   ng-class="{'text-danger': !host.sla_log.last_log_entry.passed}">
                                                    {{host.sla_log.last_log_entry.determined_availability_percent}}%
                                                </a>
                                            <?php else: ?>
                                                {{host.sla_log.last_log_entry.determined_availability_percent}}%
                                            <?php endif; ?>
                                        </td>
                                        <td>
                                            <span ng-show="host.sla_log.last_log_entry.passed"
                                                  class="badge border border-success text-success w-100">
                                                <?= __('PASSED') ?>
                                            </span>
                                            <span ng-hide="host.sla_log.last_log_entry.passed"
                                                  class="badge border border-danger text-danger w-100">
                                                <?= __('FAILED') ?>
                                            </span>
                                        </td>
                                    </tr>
                                    <tr ng-repeat="service in host.services" ng-repeat-end=""
                                        ng-if="service.sla_log.last_log_entry.evaluation_total_time_human_readable">
                                        <td class="pl-3">
                                            <i class="fas fa-cog"></i>
                                            {{service.service.servicename}}
                                        </td>
                                        <td>
                                            {{service.sla_log.last_log_entry.evaluation_total_time_human_readable}}
                                        </td>
                                        <td>
                                            {{service.sla_log.last_log_entry.determined_availability_time_human_readable}}
                                        </td>
                                        <td>
                                            {{service.sla_log.last_log_entry.determined_outage_time_human_readable}}
                                        </td>
                                        <td ng-class="{'text-danger': service.sla_log.outages.length > 0}">
                                            <?php if ($this->Acl->hasPermission('index', 'SlaAvailabilityStatusServicesLog', 'SLAModule')): ?>
                                                <a ui-sref="SlaAvailabilityStatusServicesLog({id:service.service.id, from:date_range.start, to:date_range.end})"
                                                   ng-class="{'text-danger': service.sla_log.outages.length > 0}">
                                                    {{service.sla_log.outages.length}}
                                                </a>
                                            <?php else: ?>
                                                {{service.sla_log.outages.length}}
                                            <?php endif; ?>
                                        </td>
                                        <td>
                                            {{service.sla_log.last_log_entry.minimal_availability_percent}}%
                                        </td>
                                        <td ng-class="{'text-danger': !service.sla_log.last_log_entry.passed}">
                                            <?php if ($this->Acl->hasPermission('index', 'SlaAvailabilityStatusServicesLog', 'SLAModule')): ?>
                                                <a ui-sref="SlaAvailabilityStatusServicesLog({id:service.service.id, from:date_range.start, to:date_range.end})"
                                                   ng-class="{'text-danger': !service.sla_log.last_log_entry.passed}">
                                                    {{service.sla_log.last_log_entry.determined_availability_percent}}%
                                                </a>
                                            <?php else: ?>
                                                {{service.sla_log.last_log_entry.determined_availability_percent}}%
                                            <?php endif; ?>
                                        </td>
                                        <td>
                                            <span ng-show="service.sla_log.last_log_entry.passed"
                                                  class="badge border border-success text-success w-100">
                                                <?= __('PASSED') ?>
                                            </span>
                                            <span ng-hide="service.sla_log.last_log_entry.passed"
                                                  class="badge border border-danger text-danger w-100">
                                                <?= __('FAILED') ?>
                                            </span>
                                        </td>
                                    </tr>
                                    </tbody>
                                </table>
                            </div>
                            <div ng-if="post.Sla.evaluation === 3" class="mt-2">
                                <table class="table table-striped m-0 table-bordered table-hover table-sm">
                                    <thead>
                                    <tr>
                                        <th>
                                            <?= __('Host'); ?> / <?= __('Service'); ?>
                                        </th>
                                        <th>
                                            <?= __('Total time'); ?>
                                        </th>
                                        <th>
                                            <?= __('Uptime'); ?>
                                        </th>
                                        <th>
                                            <?= __('Outage time'); ?>
                                        </th>
                                        <th>
                                            <?= __('Outages'); ?>
                                        </th>
                                        <th>
                                            <?= __('Goal(%)'); ?>
                                        </th>
                                        <th>
                                            <?= __('Achieved(%)'); ?>
                                        </th>
                                        <th>
                                            <?= __('Status'); ?>
                                        </th>
                                    </tr>

                                    </thead>
                                    <tbody>
                                    <tr ng-repeat-start="host in report.hosts[$index]">
                                        <td colspan="8">
                                            <i class="fas fa-desktop"></i>
                                            {{host.host.name}}
                                        </td>
                                    </tr>
                                    <tr ng-repeat="service in host.services" ng-repeat-end=""
                                        ng-if="service.sla_log.last_log_entry.evaluation_total_time_human_readable">
                                        <td class="pl-3">
                                            <i class="fas fa-cog"></i>
                                            {{service.service.servicename}}
                                        </td>
                                        <td>
                                            {{service.sla_log.last_log_entry.evaluation_total_time_human_readable}}
                                        </td>
                                        <td>
                                            {{service.sla_log.last_log_entry.determined_availability_time_human_readable}}
                                        </td>
                                        <td>
                                            {{service.sla_log.last_log_entry.determined_outage_time_human_readable}}
                                        </td>
                                        <td>
                                            {{service.sla_log.outages.length}}
                                        </td>
                                        <td>
                                            {{service.sla_log.last_log_entry.minimal_availability_percent}}%
                                        </td>
                                        <td>
                                            {{service.sla_log.last_log_entry.determined_availability_percent}}%
                                        </td>
                                        <td>
                                            <span ng-show="service.sla_log.last_log_entry.determined_availability_percent < service.sla_log.last_log_entry.minimal_availability_percent"
                                                  class="badge border border-danger text-danger w-100">
                                                <?= __('FAILED') ?>
                                            </span>
                                            <span ng-hide="service.sla_log.last_log_entry.determined_availability_percent < service.sla_log.last_log_entry.minimal_availability_percent"
                                                  class="badge border border-success text-success w-100">
                                                <?= __('PASSED') ?>
                                            </span>
                                        </td>
                                    </tr>
                                    </tbody>
                                </table>
                            </div>
                        </fieldset>
                    </div> <!-- end showReport -->
                </div>
            </div>
        </div>
    </div>
</div>
