<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.

?>
<ol class="breadcrumb page-breadcrumb">
    <li class="breadcrumb-item">
        <a ui-sref="DashboardsIndex">
            <i class="fa fa-home"></i> <?= __('Home'); ?>
        </a>
    </li>
    <li class="breadcrumb-item">
        <i class="fas fa-puzzle-piece"></i> <?= __('Service Level Agreement Module'); ?>
    </li>
    <li class="breadcrumb-item">
        <a ui-sref="SlasIndex">
            <i class="fa-solid fa-award"></i> <?php echo __('Service Level Agreements'); ?>
        </a>
    </li>
    <li class="breadcrumb-item">
        <i class="fa-solid fa-desktop"></i> <?= __('Service Level Agreement Affected Hosts'); ?>
    </li>
</ol>


<div class="row">
    <div class="col-xl-12">
        <div id="panel-1" class="panel">
            <div class="panel-hdr">
                <h2>
                    <?php echo __('Service Level Agreement'); ?>
                    <span class="fw-300"><i><?php echo __('Affected hosts'); ?></i></span>
                </h2>
                <div class="panel-toolbar">
                    <button class="btn btn-xs btn-primary shadow-0" ng-click="triggerFilter()">
                        <i class="fas fa-filter"></i> <?php echo __('Filter'); ?>
                    </button>
                </div>
            </div>
            <div class="panel-hdr">
                <div class="alert border-primary bg-transparent fade show w-100 margin-10" role="alert">
                    <?php if ($this->Acl->hasPermission('edit', 'Slas', 'SLAModule')): ?>
                        <span aria-hidden="true">
                            <a class="btn btn-outline-primary btn-sm btn-w-m waves-effect waves-themed pull-right"
                               ng-if="sla.allowEdit"
                               ui-sref="SlasEdit({id: sla.id})"
                               data-dismiss="modal"
                               href="#!/sla_module/Slas/edit/{{sla.id}}">
                            <i class="fas fa-tasks"></i>
                            <?= __('Go to "SLA configuration"'); ?>
                            </a>
                        </span>
                    <?php endif; ?>

                    <div class="d-flex align-items-center">
                        <div class="alert-icon">
                            <span class="icon-stack fa-3x">
                                <i class="base-2 icon-stack-3x color-primary-600"></i>
                                <i class="base-3 icon-stack-2x color-primary-700"></i>
                                <i class="ni ni-badge icon-stack-1x text-white"></i>
                            </span>
                        </div>
                        <div class="flex-1">
                            <span class="h4 text-primary">
                                <?= __('Service level Agreement: '); ?>
                                <?php if ($this->Acl->hasPermission('edit', 'Slas', 'SLAModule')): ?>
                                    <a ui-sref="SlasEdit({id: sla.id})"
                                       ng-if="sla.allowEdit">
                                            "{{ sla.name }}"
                                        </a>
                                <?php else: ?>
                                    "{{ sla.name }}"
                                <?php endif; ?>
                            </span>
                            <br>
                            <?= __('Overview of all affected hosts.  Please refresh your configuration after configuration changes!'); ?>
                        </div>
                    </div>
                </div>
            </div>
            <div class="panel-container show">
                <div class="panel-content">
                    <!-- Start Filter -->
                    <div class="list-filter card margin-bottom-10" ng-show="showFilter">
                        <div class="card-header">
                            <i class="fa fa-filter"></i> <?php echo __('Filter'); ?>
                        </div>
                        <div class="card-body">
                            <div class="row">
                                <div class="col-xs-12 col-md-6 margin-bottom-10">
                                    <div class="form-group">
                                        <div class="input-group">
                                            <div class="input-group-prepend">
                                                <span class="input-group-text"><i
                                                            class="fa fa-filter"></i></span>
                                            </div>
                                            <input type="text" class="form-control form-control-sm"
                                                   placeholder="<?php echo __('Filter by host name'); ?>"
                                                   ng-model="filter.Hosts.name"
                                                   ng-model-options="{debounce: 500}">
                                        </div>
                                    </div>
                                </div>
                            </div>

                            <div class="float-right">
                                <button type="button" ng-click="resetFilter()"
                                        class="btn btn-xs btn-danger">
                                    <?php echo __('Reset Filter'); ?>
                                </button>
                            </div>
                        </div>
                    </div>
                    <div class="frame-wrap">
                        <table class="table table-striped m-0 table-bordered table-hover table-sm">
                            <thead>
                            <tr>
                                <th class="no-sort" ng-click="orderBy('Hosts.name')">
                                    <i class="fa" ng-class="getSortClass('Hosts.name')"></i>
                                    <?php echo __('Host'); ?>
                                </th>
                                <th class="no-sort" ng-click="orderBy('Hosts.address')">
                                    <i class="fa" ng-class="getSortClass('Hosts.address')"></i>
                                    <?php echo __('Address'); ?>
                                </th>
                                <th class="no-sort">
                                    <?php echo __('Container'); ?>
                                </th>
                                <th class="no-sort">
                                    <?php echo __('Direct assignment or via the host template'); ?>
                                </th>
                            </tr>
                            </thead>

                            <tbody>
                            <tr ng-repeat="host in hosts">
                                <td>
                                    <?php if ($this->Acl->hasPermission('browser', 'hosts', '')): ?>
                                        <a ui-sref="HostsBrowser({id: host.id})">
                                            {{ host.name }}
                                        </a>
                                    <?php else: ?>
                                        {{ host.name }}
                                    <?php endif; ?>
                                </td>
                                <td>
                                    {{host.address}}
                                </td>
                                <td>
                                    {{host.primary_container}}
                                </td>
                                <td>
                                    <span ng-show="host.sla_id > 0">
                                        <i class="fa-solid fa-file-contract color-primary-700"></i>
                                        <i class="fa-solid fa-arrow-right-long"></i>
                                        <span>
                                            <i class="fa fa-desktop color-primary-700 width-15"></i>
                                            <?php if ($this->Acl->hasPermission('edit', 'hosts')): ?>
                                                <a ui-sref="HostsEdit({id: host.id})">
                                                    {{host.name}}
                                                </a>
                                                <span ng-hide="host.allowEdit">
                                                {{host.name}}
                                            </span>
                                            <?php else: ?>
                                                {{host.name}}
                                            <?php endif; ?>
                                        </span>
                                    </span>
                                    <span ng-hide="host.sla_id > 0">
                                        <i class="fa-solid fa-file-contract color-primary-700"></i>
                                        <i class="fa-solid fa-arrow-right-long"></i>
                                        <span>
                                            <i class="fa fa-pencil-square-o color-primary-700 width-15"></i>
                                            <?php if ($this->Acl->hasPermission('edit', 'hosttemplates')): ?>
                                                <a ui-sref="HosttemplatesEdit({id: host.hosttemplate.id})">
                                                    {{host.hosttemplate.name}}
                                                </a>
                                                <span ng-hide="host.hosttemplate.allowEdit">
                                                {{host.hosttemplate.name}}
                                            </span>
                                            <?php else: ?>
                                                {{host.hosttemplate.name}}
                                            <?php endif; ?>
                                        </span>
                                    </span>
                                </td>
                            </tr>

                            </tbody>
                        </table>
                        <div class="margin-top-10" ng-show="hosts.length == 0">
                            <div class="text-center text-danger italic">
                                <?php echo __('No entries match the selection'); ?>
                            </div>
                        </div>

                        <scroll scroll="scroll" click-action="changepage" ng-if="scroll"></scroll>
                        <paginator paging="paging" click-action="changepage" ng-if="paging"></paginator>
                        <?php echo $this->element('paginator_or_scroll'); ?>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
