<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.

?>
<ol class="breadcrumb page-breadcrumb">
    <li class="breadcrumb-item">
        <a ui-sref="DashboardsIndex">
            <i class="fa fa-home"></i> <?= __('Home'); ?>
        </a>
    </li>
    <li class="breadcrumb-item">
        <i class="fas fa-puzzle-piece"></i> <?= __('Service Level Agreement Module'); ?>
    </li>
    <li class="breadcrumb-item">
        <i class="fa-solid fa-award"></i> <?= __('Service Level Agreements'); ?>
    </li>
</ol>

<!-- ANGAULAR DIRECTIVES -->
<massdelete></massdelete>

<div class="row">
    <div class="col-xl-12">
        <div id="panel-1" class="panel">
            <div class="panel-hdr">
                <h2>
                    <?= __('Service Level Agreements'); ?>
                    <span class="fw-300"><i><?= __('overview'); ?></i></span>
                </h2>
                <div class="panel-toolbar">
                    <button class="btn btn-xs btn-default mr-1 shadow-0" ng-click="load()">
                        <i class="fas fa-sync"></i> <?= __('Refresh'); ?>
                    </button>
                    <?php if ($this->Acl->hasPermission('add', 'Slas', 'SLAModule')): ?>
                        <button class="btn btn-xs btn-success mr-1 shadow-0"
                                ui-sref="SlasAdd">
                            <i class="fas fa-plus"></i> <?= __('New'); ?>
                        </button>
                    <?php endif; ?>
                    <button class="btn btn-xs btn-primary shadow-0" ng-click="triggerFilter()">
                        <i class="fas fa-filter"></i> <?= __('Filter'); ?>
                    </button>
                </div>
            </div>
            <div class="panel-container show">
                <div class="panel-content">
                    <!-- Start Filter -->
                    <div class="list-filter card margin-bottom-10" ng-show="showFilter">
                        <div class="card-header">
                            <i class="fa fa-filter"></i> <?= __('Filter'); ?>
                        </div>
                        <div class="card-body">
                            <div class="row">
                                <div class="col-xs-12 col-md-6 margin-bottom-10">
                                    <div class="form-group">
                                        <div class="input-group">
                                            <div class="input-group-prepend">
                                                <span class="input-group-text"><i
                                                            class="fa fa-filter"></i></span>
                                            </div>
                                            <input type="text" class="form-control form-control-sm"
                                                   placeholder="<?= __('Filter by sla name'); ?>"
                                                   ng-model="filter.Slas.name"
                                                   ng-model-options="{debounce: 500}">
                                        </div>
                                    </div>
                                </div>
                                <div class="col-xs-12 col-md-6 margin-bottom-10">
                                    <div class="form-group">
                                        <div class="input-group">
                                            <div class="input-group-prepend">
                                                <span class="input-group-text"><i class="fa fa-filter"></i></span>
                                            </div>
                                            <input type="text" class="form-control form-control-sm"
                                                   placeholder="<?= __('Filter by sla description'); ?>"
                                                   ng-model="filter.Slas.description"
                                                   ng-model-options="{debounce: 500}">
                                        </div>
                                    </div>
                                </div>
                            </div>

                            <div class="float-right">
                                <button type="button" ng-click="resetFilter()"
                                        class="btn btn-xs btn-danger">
                                    <?= __('Reset Filter'); ?>
                                </button>
                            </div>
                        </div>
                    </div>
                    <!-- End Filter -->

                    <div class="frame-wrap">
                        <table class="table table-striped m-0 table-bordered table-hover table-sm">
                            <thead>
                            <tr>
                                <th class="no-sort sorting_disabled width-15">
                                    <i class="fa fa-check-square"></i>
                                </th>
                                <th class="no-sort" ng-click="orderBy('Slas.name')">
                                    <i class="fa" ng-class="getSortClass('Slas.name')"></i>
                                    <?= __('Name'); ?>
                                </th>

                                <th class="no-sort" ng-click="orderBy('Slas.description')">
                                    <i class="fa" ng-class="getSortClass('Slas.description')"></i>
                                    <?= __('Description'); ?>
                                </th>

                                <th class="no-sort" ng-click="orderBy('Slas.evaluation_interval')">
                                    <i class="fa" ng-class="getSortClass('Slas.evaluation_interval')"></i>
                                    <?= __('Evaluation interval'); ?>
                                </th>

                                <th class="no-sort">
                                    <?= __('Timeperiod'); ?>
                                </th>

                                <th class="no-sort" ng-click="orderBy('Slas.start_date')">
                                    <i class="fa" ng-class="getSortClass('Slas.start_date')"></i>
                                    <?= __('Start date'); ?>
                                </th>

                                <th class="no-sort">
                                    <?= __('Container'); ?>
                                </th>

                                <th>
                                    <?= __('Thresholds'); ?>
                                </th>

                                <th>
                                    <?= __('Achieved'); ?>(%)
                                </th>

                                <th>
                                    <?= __('Status'); ?>
                                </th>

                                <th class="no-sort text-center editItemWidth">
                                    <i class="fa fa-gear fa-lg"></i>
                                </th>
                            </tr>
                            </thead>

                            <tbody>
                            <tr ng-repeat="sla in slas">
                                <td class="text-center" class="width-15">
                                    <?php if ($this->Acl->hasPermission('delete', 'Slas', 'SLAModule')): ?>
                                        <input type="checkbox"
                                               ng-model="massChange[sla.id]"
                                               ng-show="sla.allowEdit">
                                    <?php endif; ?>
                                </td>
                                <td>
                                    <?php if ($this->Acl->hasPermission('viewDetails', 'Slas', 'SLAModule')): ?>
                                        <a ui-sref="SlasViewDetails({id: sla.id})">
                                            {{ sla.name }}
                                        </a>
                                    <?php else: ?>
                                        {{ sla.name }}
                                    <?php endif; ?>
                                </td>
                                <td>
                                    {{ sla.description }}
                                </td>
                                <td>
                                    {{ sla.evaluation_interval }}
                                </td>
                                <td>
                                    <?php if ($this->Acl->hasPermission('edit', 'timeperiods')): ?>
                                        <a ui-sref="TimeperiodsEdit({id:sla.timeperiod_id})">
                                            {{ sla.timeperiod.name }}
                                        </a>
                                    <?php else: ?>
                                        {{ sla.timeperiod.name }}
                                    <?php endif; ?>
                                </td>
                                <td>
                                    {{ sla.start_date }}
                                </td>
                                <td>
                                    {{ sla.container }}
                                </td>

                                <td>
                                    <div class="badge border border-warning text-warning"
                                         ng-show="sla.warning_threshold">
                                        <i class="fa-solid fa-less-than"></i>
                                        {{sla.warning_threshold}} %
                                    </div>
                                    <div class="badge border border-danger text-danger"
                                         ng-show="sla.minimal_availability">
                                        <i class="fa-solid fa-less-than"></i>
                                        {{sla.minimal_availability}} %
                                    </div>
                                </td>

                                <td>
                                    <span ng-show="sla.status_percent"
                                          ng-class="{'text-success': sla.fulfill, 'text-danger': !sla.fulfill}">
                                         <?php if ($this->Acl->hasPermission('viewDetails', 'Slas', 'SLAModule')): ?>
                                             <a ui-sref="SlasViewDetails({id: sla.id})" class="pointer"
                                                ng-class="{'text-success': sla.fulfill, 'text-danger': !sla.fulfill}">
                                                {{sla.status_percent}}%
                                            </a>
                                         <?php else: ?>
                                             {{sla.status_percent}}%
                                         <?php endif; ?>
                                    </span>
                                    <div ng-show="sla.status_percent === null" class="w-100 text-center">
                                        <i class="fa-solid fa-minus text-primary"></i>
                                    </div>
                                </td>

                                <td>
                                    <div ng-show="sla.status_percent">
                                        <span ng-show="sla.fulfill"
                                              class="badge border border-success text-success w-100">
                                            <?= __('PASSED') ?>
                                        </span>
                                        <span ng-hide="sla.fulfill"
                                              class="badge border border-danger text-danger w-100">
                                            <?= __('FAILED') ?>
                                        </span>
                                    </div>
                                    <div ng-show="sla.status_percent === null" class="w-100 text-center">
                                        <i class="fa-solid fa-minus text-primary"></i>
                                    </div>
                                </td>

                                <td class="width-50">
                                    <div class="btn-group btn-group-xs" role="group">
                                        <?php if ($this->Acl->hasPermission('edit', 'Slas', 'SLAModule')): ?>
                                            <a ui-sref="SlasEdit({id: sla.id})"
                                               ng-if="sla.allowEdit"
                                               class="btn btn-default btn-lower-padding">
                                                <i class="fa fa-cog"></i>
                                            </a>
                                            <a href="javascript:void(0);"
                                               ng-if="!sla.allowEdit"
                                               class="btn btn-default btn-lower-padding disabled">
                                                <i class="fa fa-cog"></i>
                                            </a>
                                        <?php else: ?>
                                            <a href="javascript:void(0);"
                                               class="btn btn-default btn-lower-padding disabled">
                                                <i class="fa fa-cog"></i></a>
                                        <?php endif; ?>
                                        <button type="button"
                                                class="btn btn-default dropdown-toggle btn-lower-padding"
                                                data-toggle="dropdown">
                                            <i class="caret"></i>
                                        </button>
                                        <div class="dropdown-menu dropdown-menu-right">
                                            <?php if ($this->Acl->hasPermission('edit', 'Slas', 'SLAModule')): ?>
                                                <a ui-sref="SlasEdit({id: sla.id})"
                                                   ng-if="sla.allowEdit"
                                                   class="dropdown-item">
                                                    <i class="fa fa-cog"></i>
                                                    <?php echo __('Edit'); ?>
                                                </a>
                                            <?php endif; ?>
                                            <?php if ($this->Acl->hasPermission('viewDetails', 'Slas', 'SLAModule')): ?>
                                                <a ui-sref="SlasViewDetails({id: sla.id})"
                                                   class="dropdown-item">
                                                    <i class="fa-solid fa-clipboard-list"></i>
                                                    <?php echo __('View details'); ?>
                                                </a>
                                            <?php endif; ?>
                                            <?php if ($this->Acl->hasPermission('assignToHosts', 'HostMappingRules', 'SLAModule')): ?>
                                                <a ui-sref="HostMappingRules({id:sla.id})"
                                                   ng-if="sla.allowEdit"
                                                   class="dropdown-item">
                                                    <div class="icon-stack">
                                                        <i class="fas fa-desktop opacity-100 "></i>
                                                        <i class="fa-solid fa-plus opacity-100 fa-xs text-success cornered cornered-lr"></i>
                                                    </div>
                                                    <?php echo __('Assign to hosts'); ?>
                                                </a>
                                            <?php endif; ?>
                                            <?php if ($this->Acl->hasPermission('hosts', 'Slas', 'SLAModule')): ?>
                                                <a ui-sref="SlasHosts({id: sla.id})"
                                                   class="dropdown-item">
                                                    <div class="icon-stack">
                                                        <i class="fas fa-desktop opacity-100 "></i>
                                                        <i class="fa-solid fa-award opacity-100 fa-xs cornered cornered-lr color-warning-800"></i>
                                                    </div>
                                                    <?php echo __('Affected hosts'); ?>
                                                </a>
                                            <?php endif; ?>
                                            <?php if ($this->Acl->hasPermission('generate', 'Slas', 'SLAModule')): ?>
                                                <div class="dropdown-divider"></div>
                                                <a class="dropdown-item"
                                                   ui-sref="SlasGenerateReport({id: sla.id })">
                                                    <i class="fa fa-file-invoice"></i>
                                                    <?php echo __('Generate report'); ?>
                                                </a>
                                            <?php endif; ?>
                                            <?php if ($this->Acl->hasPermission('delete', 'Slas', 'SLAModule')): ?>
                                                <div class="dropdown-divider"></div>
                                                <a ng-if="sla.allowEdit"
                                                   ng-click="confirmDelete(getObjectForDelete(sla))"
                                                   href="javascript:void(0);"
                                                   class="dropdown-item txt-color-red">
                                                    <i class="fa fa-trash"></i>
                                                    <?php echo __('Delete'); ?>
                                                </a>
                                            <?php endif; ?>
                                        </div>
                                    </div>
                                </td>
                            </tr>
                            </tbody>
                        </table>
                        <div class="margin-top-10" ng-show="slas.length == 0">
                            <div class="text-center text-danger italic">
                                <?php echo __('No entries match the selection'); ?>
                            </div>
                        </div>
                        <div class="row margin-top-10 margin-bottom-10">
                            <div class="col-xs-12 col-md-2 text-muted text-center">
                                <span ng-show="selectedElements > 0">({{selectedElements}})</span>
                            </div>
                            <div class="col-xs-12 col-md-2">
                                <span ng-click="selectAll()" class="pointer">
                                    <i class="fas fa-lg fa-check-square"></i>
                                    <?php echo __('Select all'); ?>
                                </span>
                            </div>
                            <div class="col-xs-12 col-md-2">
                                <span ng-click="undoSelection()" class="pointer">
                                    <i class="fas fa-lg fa-square"></i>
                                    <?php echo __('Undo selection'); ?>
                                </span>
                            </div>
                            <?php if ($this->Acl->hasPermission('delete', 'Slas', 'SLAModule')): ?>
                                <div class="col-xs-12 col-md-2 txt-color-red">
                                    <span ng-click="confirmDelete(getObjectsForDelete())" class="pointer">
                                        <i class="fas fa-trash"></i>
                                        <?php echo __('Delete selected'); ?>
                                    </span>
                                </div>
                            <?php endif; ?>
                        </div>

                        <scroll scroll="scroll" click-action="changepage" ng-if="scroll"></scroll>
                        <paginator paging="paging" click-action="changepage" ng-if="paging"></paginator>
                        <?php echo $this->element('paginator_or_scroll'); ?>

                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
