<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.
?>
<div style="height:{{frontWidgetHeight}}px!important;">
    <flippy vertical
            class="col-12 fancy"
            flip="['custom:FLIP_EVENT_OUT']"
            flip-back="['custom:FLIP_EVENT_IN']"
            duration="800"
            timing-function="ease-in-out">

        <flippy-front class="fixFlippy">
            <a href="javascript:void(0);" class="btn btn-default btn-xs txt-color-blueDark" ng-click="showConfig()">
                <i class="fa fa-cog fa-sm"></i>
            </a>
            <span ng-show="sla.id === null" class="text-info padding-left-20">
                <?php echo __('No element selected'); ?>
            </span>
            <div class="no-padding">
                <div ng-if="sla.id" style="height:{{frontWidgetHeight}}px;width:{{frontWidgetWidth}}px;">
                    <?php if ($this->Acl->hasPermission('viewDetails', 'slas', 'SLAModule')): ?>
                    <div>
                        <div class="panel-hdr mt-2">
                            <h2>
                                <a ui-sref="SlasViewDetails({id: sla.id })" title="{{sla.name}}">
                                    {{sla.name}}
                                </a>
                                <span class="fw-300">
                                        <i>
                                            {{sla.description}}
                                        </i>
                                    </span>
                            </h2>
                        </div>
                        <div class="row h-100">
                            <div class="col-4">
                                <div class="card rounded-plus text-center h-100 w-100 calendar-card-shadow"
                                     ng-hide="slaStatusLog.hasOwnProperty(dateDetails.yesterday_timestamp)">
                                    <div class="card-header bg-primary text-white font-md h-25 align-items-center d-flex justify-content-center day-card-header-radius">
                                        {{dateDetails.monthName}}
                                    </div>
                                    <div id="day-{{widget.id}}"
                                         class="card-body align-items-center d-flex justify-content-center no-padding"
                                         style="font-size: {{fontSize}}px;">
                                        {{dateDetails.dayNumber}}

                                    </div>
                                    <div
                                            class="card-footer bg-primary text-center text-white font-sm h-25 align-items-center d-flex justify-content-center day-card-footer-radius">
                                        {{dateDetails.weekday}}
                                    </div>
                                </div>
                                <div class="card rounded-plus text-center h-100 w-100 calendar-card-shadow"
                                     ng-show="slaStatusLog.hasOwnProperty(dateDetails.yesterday_timestamp)">
                                    <div class="card-header bg-{{slaStatusLog[dateDetails.yesterday_timestamp].class}} text-white font-md h-25 align-items-center d-flex justify-content-center day-card-header-radius">
                                        {{dateDetails.monthName}}
                                    </div>
                                    <div id="day-{{widget.id}}"
                                         class="card-body align-items-center d-flex justify-content-center no-padding"
                                         style="font-size: {{fontSize}}px;">
                                        {{dateDetails.dayNumber}}
                                    </div>
                                    <div
                                            class="card-footer bg-{{slaStatusLog[dateDetails.yesterday_timestamp].class}} text-center no-padding text-white font-sm day-card-footer-radius">
                                        {{dateDetails.weekday}}
                                        <div class="font-lg fw-light">
                                            {{slaStatusLog[dateDetails.yesterday_timestamp].lowestValue}}%
                                        </div>

                                    </div>
                                </div>
                            </div>

                            <div class="col-8">
                                <table class="table w-100 small table-sm margin-0">
                                    <thead>
                                    <tr>
                                        <th></th>
                                        <th ng-repeat="weekdayName in dateDetails.weekdayNames">
                                            {{weekdayName}}
                                        </th>
                                    </tr>
                                    </thead>
                                    <tbody>
                                    <tr ng-repeat="week in dateDetails.days">
                                        <th class="text-primary">{{week.cw}}</th>
                                        <td ng-repeat="dayDetail in week.days"
                                            ng-class="{'bg-primary-20-alpha': dayDetail.weekday === 6, 'bg-primary-40-alpha': dayDetail.weekday === 7}">
                                            <span ng-show="slaStatusLog.hasOwnProperty(dayDetail.timestamp)"
                                                  class="badge w-100 bg-{{slaStatusLog[dayDetail.timestamp].class}} pointer text-white"
                                                  title="{{slaStatusLog[dayDetail.timestamp].lowestValue}}%">
                                                {{dayDetail.day}}
                                            </span>
                                            <span ng-hide="slaStatusLog.hasOwnProperty(dayDetail.timestamp)"
                                                  ng-class="{'badge badge-primary': dayDetail.day === dateDetails.dayNumber}">
                                                {{dayDetail.day}}
                                            </span>
                                        </td>
                                    </tr>
                                    </tbody>
                                </table>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="info-box bg-primary" ng-hide="1==1">
                    <div class="info-box-icon">
                        <i class="fa fa-lg fa-info"></i>
                    </div>
                    <div class="info-box-content txt-color-white">
                        <a ng-href="{{slaHref}}" title="{{sla.name}}"
                           class="info-box-text">
                            <span class="txt-color-white">{{sla.name}}</span>
                        </a>
                        <div class="font-lg">
                            <?php
                            echo __('No data available ');
                            ?>
                        </div>
                    </div>
                </div>
                <?php else: ?>
                    <div class="row text-center padding-20">
                            <span class="col col-lg-12 badge badge-danger font-md" style="white-space: normal;">
                                <i class="fa fa-exclamation-triangle"></i>
                                <?php echo __('You are not permitted to access this object'); ?>
                            </span>
                    </div>
                <?php endif; ?>
            </div>
        </flippy-front>
        <flippy-back>
            <a href="javascript:void(0);" class="btn btn-default btn-xs txt-color-blueDark" ng-click="hideConfig()">
                <i class="fa fa-eye fa-sm"></i>
            </a>
            <div class="col-lg-12">
                <div class="form-group" style="width: 100%;">
                    <label class="control-label">
                        <?= __('Sla'); ?>
                    </label>
                    <select data-placeholder="<?= __('Please choose'); ?>"
                            class="form-control"
                            chosen="slas"
                            ng-options="sla.key as sla.value for sla in slas"
                            ng-model="slaConfig.id">
                    </select>
                    <div class="row padding-top-10">
                        <div class="col-xs-12 col-sm-12">
                            <button class="btn btn-primary float-right"
                                    ng-click="saveSlaWidget()">
                                <?php echo __('Save'); ?>
                            </button>
                        </div>

                    </div>
                </div>
            </div>
        </flippy-back>
    </flippy>
</div>
