<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.
$weekdays = [
    1 => __('Monday'),
    2 => __('Tuesday'),
    3 => __('Wednesday'),
    4 => __('Thursday'),
    5 => __('Friday'),
    6 => __('Saturday'),
    7 => __('Sunday'),
];
?>
<div class="row">
    <div class="col-lg-12 padding-10">
        <div class="row">
            <div class="col-xs-12 col-sm-12 col-md-6">
                <div class="d-flex h-75 flex-grow">
                    <div class="col-lg-12 h-25" ng-hide="sla_information">
                        <div class="col-lg-12">
                            <div class="row alert alert-block alert-primary bg-primary-200">
                                <div class="d-flex align-items-center">
                                    <div class="alert-icon width-6">
                                        <span class="icon-stack icon-stack-md">
                                            <i class="base base-7 icon-stack-3x opacity-100 color-primary-700"></i>
                                            <i class="base base-7 icon-stack-2x opacity-100 color-primary-900"></i>
                                            <i class="ni ni-info icon-stack-1x opacity-100 color-white"></i>
                                        </span>
                                    </div>
                                    <div class="flex-1">
                                        <span class="h6">
                                            <?= __('Information!'); ?>
                                        </span>
                                        <br>
                                        <?= __('No data available '); ?>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="col-lg-6" ng-show="sla_information">
                        <h1>
                            <i class="fa-solid fa-arrow-up text-success padding-right-10"></i>
                            <?= __('Uptime'); ?>
                            <span class="pull-right text-{{sla_information.host.state}}">
                                {{sla_information.host.determined_availability_percent}}%
                            </span>
                        </h1>

                        <div class="row padding-top-10">
                            <div class="col-lg-8">
                                <?= __('Status'); ?>
                            </div>
                            <div class="col-lg-4">
                                <span class="badge border border-success text-success w-100"
                                      ng-hide="sla_information.host.state === 'danger'">
                                    <?= __('PASSED') ?>
                                </span>
                                <span class="badge border border-danger text-danger w-100"
                                      ng-show="sla_information.host.state === 'danger'">
                                    <?= __('FAILED') ?>
                                </span>
                            </div>
                        </div>
                        <div class="row padding-top-10">
                            <div class="col-lg-8">
                                <?= __('Total time'); ?>
                            </div>
                            <div class="col-lg-4">
                                {{sla_information.host.evaluation_total_time_human_readable}}
                            </div>
                            <div class="col-lg-8">
                                <?= __('Availability time'); ?>
                            </div>
                            <div class="col-lg-4">
                                {{sla_information.host.determined_availability_time_human_readable}}
                            </div>

                            <hr class="mt-2 mb-2 w-100"/>

                            <div class="col-lg-8">
                                <?= __('Total outages'); ?>
                            </div>
                            <div class="col-lg-4"
                                 ng-class="{'text-danger': sla_information.host.determined_number_outages >0 }">
                                {{sla_information.host.determined_number_outages}}
                            </div>
                            <div class="col-lg-8">
                                <?= __('Outage time'); ?>
                            </div>
                            <div class="col-lg-4">
                                {{sla_information.host.determined_outage_time_human_readable}}
                            </div>
                            <hr class="my-1 w-100"/>
                            <div class="col-lg-12 text-right italic text-secondary">
                                <i class="fa-regular fa-clock"></i> <?= __('Last update'); ?>
                                {{sla_information.host.evaluation_end}}
                            </div>
                        </div>
                    </div>
                    <div class="col-lg-6 border-left sla-service-list" ng-show="sla_information">
                        <div class="row padding-top-10">
                            <div class="col-lg-10 bold">
                                <?= __('Service'); ?>
                                <sub class="text-secondary">
                                    <?= __('limit 10'); ?>
                                </sub>
                            </div>
                            <div class="col-lg-2 bold">
                                <?= __('Achieved'); ?>(%)
                            </div>
                            <hr class="mt-1 mb-1 w-100"/>
                            <div ng-repeat-start="service in sla_information.services | limitTo : 10"
                                 class="col-lg-10 ellipsis">
                                {{service.servicename}}
                            </div>
                            <div class="col-lg-2 text-{{service.state}}" ng-repeat-end>
                                {{service.determined_availability_percent}}%
                            </div>
                        </div>
                    </div>
                </div>
                <div class="d-flex h-25 flex-grow" ng-show="sla_information">
                    <div class="col-lg-4">
                        <div class="sla-info-box bg-{{sla_information.host.state}}">
                            <span class="sla-info-box-icon" ng-switch="sla_information.host.state">
                                <i class="fa-solid fa-check" ng-switch-when="success"></i>
                                <i class="fa-solid fa-exclamation" ng-switch-when="warning"></i>
                                <i class="fa-solid fa-bolt" ng-switch-when="danger"></i>
                            </span>
                            <div class="sla-info-box-content">
                                <span class="sla-info-box-text">
                                    <?= __('Currently available'); ?>
                                </span>
                                <span class="sla-info-box-number">
                                    {{sla_information.host.determined_availability_percent}}%
                                </span>
                                <div class="progress">
                                    <div class="progress-bar"
                                         style="width: {{sla_information.host.determined_availability_percent}}%"></div>
                                </div>
                                <span class="progress-description">
                                    <i class="fa-solid fa-calendar-day"></i>
                                    {{sla_information.evaluationDateDetails.start_user_format}}
                                    <i class="fa-solid fa-minus"></i>
                                    {{sla_information.evaluationDateDetails.end_user_format}}
                                </span>
                            </div>
                        </div>
                    </div>
                    <div class="col-lg-4">
                        <div class="sla-info-box bg-{{sla_information.host.state}}">
                            <span class="sla-info-box-icon">
                                <i class="fa-solid fa-arrow-down"></i>
                            </span>
                            <div class="sla-info-box-content">
                                <span class="sla-info-box-text">
                                    <?= __('Outages'); ?>
                                </span>
                                <span class="sla-info-box-number">
                                    {{sla_information.host.determined_outage_time_percent}}%
                                </span>
                                <div class="progress">
                                    <div class="progress-bar"
                                         style="width: {{sla_information.host.determined_outage_time_percent}}%"></div>
                                </div>
                                <span class="progress-description">
                                    <span class="w-50 d-inline-block">
                                         <i class="fa-solid fa-clock-rotate-left"></i>
                                        {{sla_information.evaluationDateDetails.days_passed}}
                                    </span>
                                    <span>
                                        <i class="fa-solid fa-clock-rotate-left fa-flip-horizontal"></i>
                                        {{sla_information.evaluationDateDetails.days_left}}
                                    </span>
                                </span>
                            </div>
                        </div>
                    </div>
                    <div class="col-lg-4">
                        <div class="sla-info-box bg-success">
                            <span class="sla-info-box-icon">
                                <i class="fa-solid fa-check"></i>
                            </span>
                            <div class="sla-info-box-content">
                            <span class="sla-info-box-text">
                                <?= __('Minimal availability'); ?>
                            </span>
                                <span class="sla-info-box-number">{{sla.minimal_availability}} %</span>
                                <div class="progress">
                                    <div class="progress-bar" style="width: {{sla.minimal_availability}}%"></div>
                                </div>
                                <span class="progress-description">
                                    <?= __('Days total'); ?>:
                                    {{sla_information.evaluationDateDetails.total_days}}
                                </span>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <div class="col-xs-12 col-sm-12 col-md-6 pt-1">
                <table class="table table-bordered table-sm">
                    <tr>
                        <th class="col-3"><?= __('Name'); ?></th>
                        <td>{{sla.name}}</td>
                    </tr>
                    <tr>
                        <th class="col-3"><?= __('Description'); ?></th>
                        <td>{{sla.description}}</td>
                    </tr>
                    <tr>
                        <th class="col-3"><?= __('Evaluation interval'); ?></th>
                        <td>{{sla.evaluation_interval}}</td>
                    </tr>
                    <tr>
                        <th>
                            <?= __('Thresholds'); ?>
                        </th>
                        <td>
                            <div class="badge border border-warning text-warning"
                                 ng-show="sla.warning_threshold">
                                <i class="fa-solid fa-less-than"></i>
                                {{sla.warning_threshold}} %
                            </div>
                            <div class="badge border border-danger text-danger"
                                 ng-show="sla.minimal_availability">
                                <i class="fa-solid fa-less-than"></i>
                                {{sla.minimal_availability}} %
                            </div>
                        </td>
                    </tr>
                    <tr>
                        <th><?= __('Container'); ?></th>
                        <td>
                            <?php if ($this->Acl->hasPermission('index', 'browsers')): ?>
                                <span ng-repeat="container in sla.main_container">
                                    /
                                    <a ui-sref="BrowsersIndex({containerId: container.id})"
                                       ng-if="container.id != null">
                                        {{container.name}}
                                    </a>

                                    <span ng-if="container.id === null">
                                        {{container.name}}
                                    </span>
                                </span>
                            <?php else: ?>
                                <span ng-repeat="container in mainContainer">
                                    /
                                    {{container.name}}
                                </span>
                            <?php endif; ?>
                        </td>
                    </tr>
                    <tr>
                        <th><?= __('Consider downtimes'); ?></th>
                        <td>
                            <span class="badge badge-success"
                                  ng-show="sla.consider_downtimes">
                                <?= __('Yes'); ?>
                            </span>

                            <span class="badge badge-danger"
                                  ng-show="!sla.consider_downtimes">
                                <?= __('No'); ?>
                            </span>
                        </td>
                    </tr>
                    <tr>
                        <th><?= __('Reflection state'); ?></th>
                        <td>
                            <span ng-show="!sla.hard_state_only">
                                <?= __('soft and hard state'); ?>
                            </span>

                            <span ng-show="sla.hard_state_only">
                                <?= __('hard state only'); ?>
                            </span>
                        </td>
                    </tr>
                    <tr>
                        <th><?= __('Timeperiod'); ?></th>
                        <td>{{sla.timeperiod.name}}</td>
                    </tr>
                    <tr>
                        <td colspan="2">
                            <div class="gridContainer-weekdays">
                                <?php foreach ($weekdays as $weekday): ?>
                                    <div class="child grid bg-primary text-white small">
                                        <?= $weekday; ?>
                                    </div>
                                <?php endforeach; ?>
                                <div class="child grid" ng-repeat="weekDay in sla.weekDays">
                                    <span ng-show="weekDay.length === 0">
                                        <i class="fa-solid fa-minus text-danger"></i>
                                    </span>
                                    <ul class="no-padding inside-list fw-300" ng-show="weekDay.length > 0">
                                        <li ng-repeat="timeDetails in weekDay">
                                            {{timeDetails.start}} - {{timeDetails.end}}
                                        </li>
                                    </ul>
                                </div>
                            </div>
                        </td>
                    </tr>
                </table>
            </div>
        </div>
    </div>
    <div class="col-lg-12 padding-10">
        <table class="table table-bordered table-sm">
            <thead>
            <tr>
                <th>
                    <?= __('Service'); ?>
                </th>
                <th>
                    <?= __('Total time'); ?>
                </th>
                <th>
                    <?= __('Availability time'); ?>
                </th>
                <th>
                    <?= __('Total outages'); ?>
                </th>
                <th>
                    <?= __('Outage time'); ?>
                </th>
                <th>
                    <?= __('Last update'); ?>
                </th>
                <th>
                    <?= __('Goal'); ?>(%)
                </th>
                <th>
                    <?= __(' Achieved'); ?>(%)
                    <span class="pull-right">
                        <i class="fa-solid fa-arrow-down-short-wide sla-service-list-icon font-md"></i>
                    </span>
                </th>
                <th>
                    <?= __('Status'); ?>
                </th>
            </tr>
            </thead>
            <tbody>
            <tr ng-repeat="service in sla_information.services">
                <td>
                    <span class="border-left border-{{service.state}} pl-1 border-5">
                         <?php if ($this->Acl->hasPermission('browser', 'services')): ?>
                             <a ui-sref="ServicesBrowser({id:service.service_id})">
                                {{service.servicename}}
                            </a>
                         <?php else: ?>
                             {{service.servicename}}
                         <?php endif; ?>
                    </span>
                </td>
                <td>
                    {{service.evaluation_total_time_human_readable}}
                </td>
                <td>
                    {{service.determined_availability_time_human_readable}}
                </td>
                <td ng-class="{'text-danger': service.determined_number_outages >0 }">
                    {{service.determined_number_outages}}
                </td>
                <td>
                    {{service.determined_outage_time_human_readable}}
                </td>
                <td>
                    {{service.evaluation_end}}
                </td>
                <td>
                    {{service.minimal_availability_percent}}%
                </td>
                <td class="text-{{service.state}}">
                    {{service.determined_availability_percent}}%
                </td>
                <td>
                    <span class="badge border border-success text-success w-100" ng-hide="service.state === 'danger'">
                        <?= __('PASSED') ?>
                    </span>
                    <span class="badge border border-danger text-danger w-100" ng-show="service.state === 'danger'">
                        <?= __('FAILED') ?>
                    </span>
                </td>
            </tr>
            </tbody>
        </table>
    </div>
</div>
