<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.
?>
<div style="height:{{frontWidgetHeight}}px!important;">
    <flippy vertical
            class="col-12 fancy"
            flip="['custom:FLIP_EVENT_OUT']"
            flip-back="['custom:FLIP_EVENT_IN']"
            duration="800"
            timing-function="ease-in-out">

        <flippy-front class="fixFlippy">
            <a href="javascript:void(0);" class="btn btn-default btn-xs txt-color-blueDark" ng-click="showConfig()">
                <i class="fa fa-cog fa-sm"></i>
            </a>
            <span ng-show="sla.id === null" class="text-info padding-left-20">
                <?php echo __('No element selected'); ?>
            </span>
            <div class="no-padding">
                <div ng-if="sla.id" style="height:{{frontWidgetHeight}}px;width:{{frontWidgetWidth}}px;">
                    <?php if ($this->Acl->hasPermission('viewDetails', 'slas', 'SLAModule')): ?>
                        <div ng-show="SlaAvailabilityView">
                            <div>
                                <div class="panel-hdr mt-2">
                                    <h2>
                                        <a ui-sref="SlasViewDetails({id: sla.id })" title="{{sla.name}}">
                                            {{sla.name}}
                                        </a>
                                        <span class="fw-300">
                                        <i>
                                            {{sla.description}}
                                        </i>
                                    </span>
                                    </h2>
                                </div>
                                <div class="row">
                                    <div class="col-4 bold text-primary">
                                        <?= __('Container'); ?>
                                    </div>
                                    <div class="col-4 bold text-primary">
                                        <?= __('Number of hosts'); ?>
                                    </div>
                                    <div class="col-4 bold text-primary border-left">
                                        <?= __('Number of services'); ?>
                                    </div>
                                </div>
                                <div class="row fieldset-legend-border-bottom border-1">
                                    <div class="col-4 text-right bold">
                                        <?= __('Total'); ?>:
                                    </div>

                                    <div class="col-4 bold">
                                        {{sla.hostsCount}}
                                    </div>
                                    <div class="col-4 border-left bold">
                                        {{sla.servicesCount}}
                                    </div>
                                </div>
                                <div class="row pt-1">
                                    <div class="col-2 offset-4">
                                        <div class="badge border border-success text-success w-100">
                                            <?= __('Host UP'); ?>
                                            <i class="fa-solid fa-circle-arrow-up text-success"></i>
                                        </div>
                                    </div>
                                    <div class="col-2">
                                        <div class="badge border border-danger text-danger w-100">
                                            <?= __('Host DOWN'); ?>
                                            <i class="fa-solid fa-circle-arrow-down text-danger"></i>
                                        </div>
                                    </div>
                                    <div class="col-2">
                                        <div class="badge border border-success text-success w-100">
                                            <?= __('Service UP'); ?>
                                            <i class="fa-solid fa-circle-arrow-up text-success"></i>
                                        </div>
                                    </div>
                                    <div class="col-2">
                                        <div class="badge border border-danger text-danger w-100">
                                            <?= __('Service DOWN'); ?>
                                            <i class="fa-solid fa-circle-arrow-down text-danger"></i>
                                        </div>
                                    </div>
                                </div>
                                <div class="row pt-1" ng-repeat="hostAndServicePerContainer in SlaAvailabilityView">
                                    <div class="col-4">
                                        {{hostAndServicePerContainer.container.full_path}}
                                    </div>
                                    <div class="col-2">
                                        <span>
                                            <?php if ($this->Acl->hasPermission('index', 'hosts', '')): ?>
                                                <span class="pointer"
                                                      ng-show="hostAndServicePerContainer.hosts.passed.count>0"
                                                      ui-sref="HostsIndex({id: hostAndServicePerContainer.hosts.passed.ids})">
                                                    {{hostAndServicePerContainer.hosts.passed.count}}
                                                    <span class="opacity-50 ml-2">
                                                        ({{hostAndServicePerContainer.hosts.passed.percentage}})
                                                    </span>
                                                </span>
                                                <span ng-hide="hostAndServicePerContainer.hosts.passed.count>0">
                                                    {{hostAndServicePerContainer.hosts.passed.count}}
                                                    <span class="opacity-50 ml-2">
                                                        ({{hostAndServicePerContainer.hosts.passed.percentage}})
                                                    </span>
                                                </span>
                                            <?php else: ?>
                                                {{hostAndServicePerContainer.hosts.passed.count}}
                                                <span class="opacity-50 ml-2">
                                                    ({{hostAndServicePerContainer.hosts.passed.percentage}})
                                                </span>
                                            <?php endif; ?>
                                        </span>
                                    </div>
                                    <div class="col-2">
                                        <span ng-class="{'text-danger': hostAndServicePerContainer.hosts.failed.count>0}">
                                            <?php if ($this->Acl->hasPermission('index', 'hosts', '')): ?>
                                                <span class="pointer"
                                                      ng-show="hostAndServicePerContainer.hosts.failed.count>0"
                                                      ui-sref="HostsIndex({id: hostAndServicePerContainer.hosts.failed.ids})">
                                                    {{hostAndServicePerContainer.hosts.failed.count}}
                                                    <span class="opacity-50 ml-2">
                                                        ({{hostAndServicePerContainer.hosts.failed.percentage}})
                                                    </span>
                                                </span>
                                                <span ng-hide="hostAndServicePerContainer.hosts.failed.count>0">
                                                    {{hostAndServicePerContainer.hosts.failed.count}}
                                                    <span class="opacity-50 ml-2">
                                                        ({{hostAndServicePerContainer.hosts.failed.percentage}})
                                                    </span>
                                                </span>
                                            <?php else: ?>
                                                {{hostAndServicePerContainer.hosts.failed.count}}
                                                <span class="opacity-50 ml-2">
                                                    ({{hostAndServicePerContainer.hosts.failed.percentage}})
                                                </span>
                                            <?php endif; ?>
                                        </span>
                                    </div>
                                    <div class="col-2">
                                        <span>
                                            <?php if ($this->Acl->hasPermission('index', 'services', '')): ?>
                                                <span class="pointer"
                                                      ng-show="hostAndServicePerContainer.services.passed.count>0"
                                                      ui-sref="ServicesIndex({id: hostAndServicePerContainer.services.passed.ids})">
                                                    {{hostAndServicePerContainer.services.passed.count}}
                                                    <span class="opacity-50 ml-2">
                                                        ({{hostAndServicePerContainer.services.passed.percentage}})
                                                    </span>
                                                </span>
                                                <span ng-hide="hostAndServicePerContainer.services.passed.count>0">
                                                    {{hostAndServicePerContainer.services.passed.count}}
                                                    <span class="opacity-50 ml-2">
                                                        ({{hostAndServicePerContainer.services.passed.percentage}})
                                                    </span>
                                                </span>
                                            <?php else: ?>
                                                {{hostAndServicePerContainer.services.passed.count}}
                                                <span class="opacity-50 ml-2">
                                                    ({{hostAndServicePerContainer.services.passed.percentage}})
                                                </span>
                                            <?php endif; ?>
                                        </span>
                                    </div>
                                    <div class="col-2">
                                        <span ng-class="{'text-danger': hostAndServicePerContainer.services.failed.count>0}">
                                            <?php if ($this->Acl->hasPermission('index', 'services', '')): ?>
                                                <span class="pointer"
                                                      ng-show="hostAndServicePerContainer.services.failed.count>0"
                                                      ui-sref="ServicesIndex({id: hostAndServicePerContainer.services.failed.ids})">
                                                    {{hostAndServicePerContainer.services.failed.count}}
                                                    <span class="opacity-50 ml-2">
                                                        ({{hostAndServicePerContainer.services.failed.percentage}})
                                                    </span>
                                                </span>
                                                <span ng-hide="hostAndServicePerContainer.services.failed.count>0">
                                                    {{hostAndServicePerContainer.services.failed.count}}
                                                    <span class="opacity-50 ml-2">
                                                        ({{hostAndServicePerContainer.services.failed.percentage}})
                                                    </span>
                                                </span>
                                            <?php else: ?>
                                                {{hostAndServicePerContainer.services.failed.count}}
                                                <span class="opacity-50 ml-2">
                                                    ({{hostAndServicePerContainer.services.failed.percentage}})
                                                </span>
                                            <?php endif; ?>
                                        </span>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="info-box bg-primary" ng-hide="SlaAvailabilityView">
                            <div class="info-box-icon">
                                <i class="fa fa-lg fa-info"></i>
                            </div>
                            <div class="info-box-content txt-color-white">
                                <a ng-href="{{slaHref}}" title="{{sla.name}}"
                                   class="info-box-text">
                                    <span class="txt-color-white">{{sla.name}}</span>
                                </a>
                                <div class="font-lg">
                                    <?php
                                    echo __('No data available ');
                                    ?>
                                </div>
                            </div>
                        </div>
                    <?php else: ?>
                        <div class="row text-center padding-20">
                            <span class="col col-lg-12 badge badge-danger font-md" style="white-space: normal;">
                                <i class="fa fa-exclamation-triangle"></i>
                                <?php echo __('You are not permitted to access this object'); ?>
                            </span>
                        </div>
                    <?php endif; ?>
                </div>
            </div>
        </flippy-front>
        <flippy-back>
            <a href="javascript:void(0);" class="btn btn-default btn-xs txt-color-blueDark" ng-click="hideConfig()">
                <i class="fa fa-eye fa-sm"></i>
            </a>
            <div class="col-lg-12">
                <div class="form-group" style="width: 100%;">
                    <label class="control-label">
                        <?= __('Sla'); ?>
                    </label>
                    <select data-placeholder="<?= __('Please choose'); ?>"
                            class="form-control"
                            chosen="slas"
                            ng-options="sla.key as sla.value for sla in slas"
                            ng-model="slaConfig.id">
                    </select>
                    <div class="row padding-top-10">
                        <div class="col-xs-12 col-sm-12">
                            <button class="btn btn-primary float-right"
                                    ng-click="saveSlaWidget()">
                                <?php echo __('Save'); ?>
                            </button>
                        </div>

                    </div>
                </div>
            </div>
        </flippy-back>
    </flippy>
</div>
