<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.
?>
<div style="height:{{frontWidgetHeight}}px!important;">
    <flippy vertical
            class="col-12 fancy"
            flip="['custom:FLIP_EVENT_OUT']"
            flip-back="['custom:FLIP_EVENT_IN']"
            duration="800"
            timing-function="ease-in-out">

        <flippy-front class="fixFlippy">
            <a href="javascript:void(0);" class="btn btn-default btn-xs txt-color-blueDark" ng-click="showConfig()">
                <i class="fa fa-cog fa-sm"></i>
            </a>
            <span ng-show="sla.id === null" class="text-info padding-left-20">
                <?php echo __('No element selected'); ?>
            </span>
            <div class="no-padding">
                <div ng-if="sla.id" style="height:{{frontWidgetHeight}}px;width:{{frontWidgetWidth}}px;">
                    <?php if ($this->Acl->hasPermission('viewDetails', 'slas', 'SLAModule')): ?>
                        <div ng-show="SlaAvailabilityView">
                            <div>
                                <div class="panel-hdr mt-2">
                                    <h2>
                                        <a ui-sref="SlasViewDetails({id: sla.id })" title="{{sla.name}}">
                                            {{sla.name}}
                                        </a>
                                        <span class="fw-300">
                                        <i>
                                            {{sla.description}}
                                        </i>
                                    </span>
                                    </h2>
                                </div>
                                <div class="row">
                                    <div class="col-4 offset-4 bold text-primary">
                                        <?= __('Number of hosts'); ?>
                                    </div>
                                    <div class="col-4 bold text-primary border-left">
                                        <?= __('Number of services'); ?>
                                    </div>
                                </div>
                                <div class="row fieldset-legend-border-bottom border-1">
                                    <div class="col-4 text-right bold">
                                        <?= __('Total'); ?>:
                                    </div>

                                    <div class="col-4">
                                        {{SlaAvailabilityView.hosts.totalHosts}}
                                    </div>
                                    <div class="col-4 border-left">
                                        {{SlaAvailabilityView.services.totalServices}}
                                    </div>
                                </div>
                                <div class="row py-1">
                                    <div class="col-4">
                                        <div class="btn btn-danger btn-xs w-100"
                                             ng-class="{'opacity-25': SlaAvailabilityView.hosts.failed.count === 0 && SlaAvailabilityView.services.failed.count === 0}">
                                            <i class="fa-solid fa-bolt"></i>
                                            <?= __('Failed'); ?>
                                        </div>
                                    </div>
                                    <div class="col-4"
                                         ng-class="{'text-danger': SlaAvailabilityView.hosts.failed.count > 0}">
                                        <?php if ($this->Acl->hasPermission('index', 'hosts', '')): ?>
                                            <span class="pointer"
                                                  ng-show="SlaAvailabilityView.hosts.failed.count>0"
                                                  ui-sref="HostsIndex({id: SlaAvailabilityView.hosts.failed.ids})">
                                                {{SlaAvailabilityView.hosts.failed.count}}
                                                <span class="opacity-50 ml-2">
                                                    ({{SlaAvailabilityView.hosts.failed.percentage}})
                                                </span>
                                            </span>
                                            <span ng-hide="SlaAvailabilityView.hosts.failed.count>0">
                                                {{SlaAvailabilityView.hosts.failed.count}}
                                                <span class="opacity-50 ml-2">
                                                    ({{SlaAvailabilityView.hosts.failed.percentage}})
                                                </span>
                                            </span>
                                        <?php else: ?>
                                            {{SlaAvailabilityView.hosts.failed.count}}
                                            <span class="opacity-50 ml-2">
                                                ({{SlaAvailabilityView.hosts.failed.percentage}})
                                            </span>
                                        <?php endif; ?>
                                    </div>
                                    <div class="col-4 border-left"
                                         ng-class="{'text-danger': SlaAvailabilityView.services.failed.count > 0}">
                                        <?php if ($this->Acl->hasPermission('index', 'services', '')): ?>
                                            <span class="pointer"
                                                  ng-show="SlaAvailabilityView.services.failed.count>0"
                                                  ui-sref="ServicesIndex({id: SlaAvailabilityView.services.failed.ids})">
                                                {{SlaAvailabilityView.services.failed.count}}
                                                <span class="opacity-50 ml-2">
                                                    ({{SlaAvailabilityView.services.failed.percentage}})
                                                </span>
                                            </span>
                                            <span ng-hide="SlaAvailabilityView.services.failed.count>0">
                                                {{SlaAvailabilityView.services.failed.count}}
                                                <span class="opacity-50 ml-2">
                                                    ({{SlaAvailabilityView.services.failed.percentage}})
                                                </span>
                                            </span>
                                        <?php else: ?>
                                            {{SlaAvailabilityView.services.failed.count}}
                                            <span class="opacity-50 ml-2">
                                                ({{SlaAvailabilityView.services.failed.percentage}})
                                            </span>
                                        <?php endif; ?>
                                    </div>
                                </div>
                                <div class="row py-1">
                                    <div class="col-4">
                                        <div class="btn btn-warning btn-xs w-100"
                                             ng-class="{'opacity-25': SlaAvailabilityView.hosts.warning.count === 0 && SlaAvailabilityView.services.warning.count === 0}">
                                            <i class="fa-solid fa-triangle-exclamation"></i>
                                            <?= __('Warning'); ?>
                                        </div>
                                    </div>
                                    <div class="col-4">
                                        <?php if ($this->Acl->hasPermission('index', 'hosts', '')): ?>
                                            <span class="pointer"
                                                  ng-show="SlaAvailabilityView.hosts.warning.count>0"
                                                  ui-sref="HostsIndex({id: SlaAvailabilityView.hosts.warning.ids})">
                                                {{SlaAvailabilityView.hosts.warning.count}}
                                                <span class="opacity-50 ml-2">
                                                    ({{SlaAvailabilityView.hosts.warning.percentage}})
                                                </span>
                                            </span>
                                            <span ng-hide="SlaAvailabilityView.hosts.warning.count>0">
                                                {{SlaAvailabilityView.hosts.warning.count}}
                                                <span class="opacity-50 ml-2">
                                                    ({{SlaAvailabilityView.hosts.warning.percentage}})
                                                </span>
                                            </span>
                                        <?php else: ?>
                                            {{SlaAvailabilityView.hosts.warning.count}}
                                            <span class="opacity-50 ml-2">
                                                ({{SlaAvailabilityView.hosts.warning.percentage}})
                                            </span>
                                        <?php endif; ?>
                                    </div>
                                    <div class="col-4 border-left">
                                        <?php if ($this->Acl->hasPermission('index', 'services', '')): ?>
                                            <span class="pointer"
                                                  ng-show="SlaAvailabilityView.services.warning.count>0"
                                                  ui-sref="ServicesIndex({id: SlaAvailabilityView.services.warning.ids})">
                                                {{SlaAvailabilityView.services.warning.count}}
                                                <span class="opacity-50 ml-2">
                                                    ({{SlaAvailabilityView.services.warning.percentage}})
                                                </span>
                                            </span>
                                            <span ng-hide="SlaAvailabilityView.services.warning.count>0">
                                            {{SlaAvailabilityView.services.warning.count}}
                                                <span class="opacity-50 ml-2">
                                                    ({{SlaAvailabilityView.services.warning.percentage}})
                                                </span>
                                        </span>
                                        <?php else: ?>
                                            {{SlaAvailabilityView.services.warning.count}}
                                            <span class="opacity-50 ml-2">
                                                ({{SlaAvailabilityView.services.warning.percentage}})
                                            </span>
                                        <?php endif; ?>
                                    </div>
                                </div>
                                <div class="row py-1">
                                    <div class="col-4">
                                        <div class="btn btn-success btn-xs w-100"
                                             ng-class="{'opacity-25': SlaAvailabilityView.hosts.passed.count === 0 && SlaAvailabilityView.services.passed.count === 0}">
                                            <i class="fa-solid fa-check"></i>
                                            <?= __('Passed'); ?>
                                        </div>
                                    </div>
                                    <div class="col-4">
                                        <?php if ($this->Acl->hasPermission('index', 'hosts', '')): ?>
                                            <span class="pointer"
                                                  ng-show="SlaAvailabilityView.hosts.passed.count>0"
                                                  ui-sref="HostsIndex({id: SlaAvailabilityView.hosts.passed.ids})">
                                                    {{SlaAvailabilityView.hosts.passed.count}}
                                                    <span class="opacity-50 ml-2">
                                                        ({{SlaAvailabilityView.hosts.passed.percentage}})
                                                    </span>
                                                </span>
                                            <span ng-hide="SlaAvailabilityView.hosts.passed.count>0">
                                                        {{SlaAvailabilityView.hosts.passed.count}}
                                                <span class="opacity-50 ml-2">
                                                    ({{SlaAvailabilityView.hosts.passed.percentage}})
                                                </span>
                                            </span>
                                        <?php else: ?>
                                            {{SlaAvailabilityView.hosts.passed.count}}
                                            <span class="opacity-50 ml-2">
                                                ({{SlaAvailabilityView.hosts.passed.percentage}})
                                            </span>
                                        <?php endif; ?>
                                    </div>
                                    <div class="col-4 border-left">
                                        <?php if ($this->Acl->hasPermission('index', 'services', '')): ?>
                                            <span class="pointer" ng-show="SlaAvailabilityView.services.passed.count>0"
                                                  ui-sref="ServicesIndex({id: SlaAvailabilityView.services.passed.ids})">
                                                    {{SlaAvailabilityView.services.passed.count}}
                                                    <span class="opacity-50 ml-2">
                                                        ({{SlaAvailabilityView.services.passed.percentage}})
                                                    </span>
                                            </span>
                                            <span ng-hide="SlaAvailabilityView.services.passed.count>0">
                                                        {{SlaAvailabilityView.services.passed.count}}
                                                 <span class="opacity-50 ml-2">
                                                    ({{SlaAvailabilityView.services.passed.percentage}})
                                                </span>
                                           </span>
                                        <?php else: ?>
                                            {{SlaAvailabilityView.services.passed.count}}
                                            <span class="opacity-50 ml-2">
                                                ({{SlaAvailabilityView.services.passed.percentage}})
                                            </span>
                                        <?php endif; ?>
                                    </div>
                                </div>
                                <div class="row py-1">
                                    <div class="col-4">
                                        <div class="btn btn-primary btn-xs w-100"
                                             ng-class="{'opacity-25': SlaAvailabilityView.hosts.not_calculated.count === 0 && SlaAvailabilityView.services.not_calculated.count === 0}">
                                            <i class="fa-solid fa-question"></i>
                                            <?= __('Not calculated'); ?>
                                        </div>
                                    </div>
                                    <div class="col-4">
                                        <?php if ($this->Acl->hasPermission('index', 'hosts', '')): ?>
                                            <span class="pointer"
                                                  ng-show="SlaAvailabilityView.hosts.not_calculated.count>0"
                                                  ui-sref="HostsIndex({id: SlaAvailabilityView.hosts.not_calculated.ids})">
                                                        {{SlaAvailabilityView.hosts.not_calculated.count}}
                                                <span class="opacity-50 ml-2">
                                                    ({{SlaAvailabilityView.hosts.not_calculated.percentage}})
                                                </span>
                                            </span>
                                            <span ng-hide="SlaAvailabilityView.hosts.not_calculated.count>0">
                                                        {{SlaAvailabilityView.hosts.not_calculated.count}}
                                                <span class="opacity-50 ml-2">
                                                    ({{SlaAvailabilityView.hosts.not_calculated.percentage}})
                                                </span>
                                            </span>
                                        <?php else: ?>
                                            {{SlaAvailabilityView.hosts.not_calculated.count}}
                                            <span class="opacity-50 ml-2">
                                                ({{SlaAvailabilityView.hosts.not_calculated.percentage}})
                                            </span>
                                        <?php endif; ?>
                                    </div>
                                    <div class="col-4 border-left">
                                        <?php if ($this->Acl->hasPermission('index', 'services', '')): ?>
                                            <span class="pointer"
                                                  ng-show="SlaAvailabilityView.services.not_calculated.count>0"
                                                  ui-sref="ServicesIndex({id: SlaAvailabilityView.services.not_calculated.ids})">
                                                        {{SlaAvailabilityView.services.not_calculated.count}}
                                                        <span class="opacity-50 ml-2">
                                                            ({{SlaAvailabilityView.services.not_calculated.percentage}})
                                                    </span>
                                            </span>
                                            <span ng-hide="SlaAvailabilityView.services.not_calculated.count>0">
                                                {{SlaAvailabilityView.services.not_calculated.count}}
                                                <span class="opacity-50 ml-2">
                                                    ({{SlaAvailabilityView.services.not_calculated.percentage}})
                                                </span>
                                            </span>
                                        <?php else: ?>
                                            {{SlaAvailabilityView.services.not_calculated.count}}
                                            <span class="opacity-50 ml-2">
                                                ({{SlaAvailabilityView.services.not_calculated.percentage}})
                                            </span>
                                        <?php endif; ?>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="info-box bg-primary" ng-hide="SlaAvailabilityView">
                            <div class="info-box-icon">
                                <i class="fa fa-lg fa-info"></i>
                            </div>
                            <div class="info-box-content txt-color-white">
                                <a ng-href="{{slaHref}}" title="{{sla.name}}"
                                   class="info-box-text">
                                    <span class="txt-color-white">{{sla.name}}</span>
                                </a>
                                <div class="font-lg">
                                    <?php
                                    echo __('No data available ');
                                    ?>
                                </div>
                            </div>
                        </div>
                    <?php else: ?>
                        <div class="row text-center padding-20">
                            <span class="col col-lg-12 badge badge-danger font-md" style="white-space: normal;">
                                <i class="fa fa-exclamation-triangle"></i>
                                <?php echo __('You are not permitted to access this object'); ?>
                            </span>
                        </div>
                    <?php endif; ?>
                </div>
            </div>
        </flippy-front>
        <flippy-back>
            <a href="javascript:void(0);" class="btn btn-default btn-xs txt-color-blueDark" ng-click="hideConfig()">
                <i class="fa fa-eye fa-sm"></i>
            </a>
            <div class="col-lg-12">
                <div class="form-group" style="width: 100%;">
                    <label class="control-label">
                        <?= __('Sla'); ?>
                    </label>
                    <select data-placeholder="<?= __('Please choose'); ?>"
                            class="form-control"
                            chosen="slas"
                            ng-options="sla.key as sla.value for sla in slas"
                            ng-model="slaConfig.id">
                    </select>
                    <div class="row padding-top-10">
                        <div class="col-xs-12 col-sm-12">
                            <button class="btn btn-primary float-right"
                                    ng-click="saveSlaWidget()">
                                <?php echo __('Save'); ?>
                            </button>
                        </div>

                    </div>
                </div>
            </div>
        </flippy-back>
    </flippy>
</div>
