<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.
$weekdays = [
    1 => __('Monday'),
    2 => __('Tuesday'),
    3 => __('Wednesday'),
    4 => __('Thursday'),
    5 => __('Friday'),
    6 => __('Saturday'),
    7 => __('Sunday'),
];
?>

<ol class="breadcrumb page-breadcrumb">
    <li class="breadcrumb-item">
        <a ui-sref="DashboardsIndex">
            <i class="fa fa-home"></i> <?= __('Home'); ?>
        </a>
    </li>
    <li class="breadcrumb-item">
        <i class="fas fa-puzzle-piece"></i> <?= __('Service Level Agreement Module'); ?>
    </li>
    <li class="breadcrumb-item">
        <a ui-sref="SlasIndex">
            <i class="fa-solid fa-award"></i> <?php echo __('Service Level Agreements'); ?>
        </a>
    </li>
    <li class="breadcrumb-item">
        <i class="fa-solid fa-clipboard-list"></i> <?= __('View details'); ?>
    </li>
</ol>

<div class="row">
    <div class="col-xl-12">
        <div id="panel-1" class="panel">
            <div class="panel-hdr">
                <h2>
                    <?= __('Service Level Agreement'); ?>:
                    <span class="fw-300"><i>{{ sla.name }}</i></span>
                </h2>
                <div class="panel-toolbar">
                    <?php if ($this->Acl->hasPermission('index', 'Slas', 'SLAModule')): ?>
                        <a back-button href="javascript:void(0);" fallback-state='SlasIndex'
                           class="btn btn-default btn-xs mr-1 shadow-0">
                            <i class="fas fa-long-arrow-alt-left"></i> <?= __('Back'); ?>
                        </a>
                    <?php endif; ?>
                    <?php if ($this->Acl->hasPermission('edit', 'Slas', 'SLAModule')): ?>
                        <a ui-sref="SlasEdit({id: sla.id})" class="btn btn-default btn-xs mr-1 shadow-0">
                            <i class="fa fa-cog"></i> <?= __('Edit'); ?>
                        </a>
                    <?php endif; ?>
                    <button class="btn btn-xs btn-default mr-1 shadow-0" ng-click="load()">
                        <i class="fas fa-sync"></i> <?= __('Refresh'); ?>
                    </button>
                    <button class="btn btn-xs btn-primary shadow-0" ng-click="triggerFilter()">
                        <i class="fas fa-filter"></i> <?= __('Filter'); ?>
                    </button>
                </div>
            </div>
            <div class="panel-container show">
                <div class="panel-content">
                    <div class="row padding-bottom-10">
                        <div class="col-xs-12 col-md-12 col-sm-12 col-lg-3 col-xl-3 border-right">
                            <sla-availability-overview sla="sla" availability="availability"
                                                       ng-if="sla"></sla-availability-overview>
                        </div>
                        <div class="col-xs-12 col-md-12 col-sm-12 col-lg-3 col-xl-3 padding-top-10">
                            <div class="row">
                                <div class="col-lg-5 col-md-12 col-xs-12">
                                    <?= __('Evaluation interval'); ?>:
                                </div>
                                <div class="col-lg-7 col-md-12 col-xs-12">
                                    {{sla.evaluation_interval}}
                                </div>
                            </div>
                            <div class="row pt-2">
                                <div class="col-lg-5 col-md-12 col-xs-12">
                                    <?= __('Thresholds'); ?>:
                                </div>
                                <div class="col-lg-7 col-md-12 col-xs-12">
                                    <div class="badge border border-warning text-warning"
                                         ng-show="sla.warning_threshold">
                                        <i class="fa-solid fa-less-than"></i>
                                        {{sla.warning_threshold}} %
                                    </div>
                                    <div class="badge border border-danger text-danger"
                                         ng-show="sla.minimal_availability">
                                        <i class="fa-solid fa-less-than"></i>
                                        {{sla.minimal_availability}} %
                                    </div>
                                </div>
                            </div>
                            <div class="row pt-2">
                                <div class="col-lg-5 col-md-12 col-xs-12">
                                    <?= __('Container'); ?>:
                                </div>
                                <div class="col-lg-7 col-md-12 col-xs-12">
                                    <?php if ($this->Acl->hasPermission('index', 'browsers')): ?>
                                        <span ng-repeat="container in sla.main_container">/
                                            <a ui-sref="BrowsersIndex({containerId: container.id})"
                                               ng-if="container.id != null">
                                                {{container.name}}
                                            </a>

                                            <span ng-if="container.id === null">
                                                {{container.name}}
                                            </span>
                                        </span>
                                    <?php else: ?>
                                        <span ng-repeat="container in mainContainer">/
                                            {{container.name}}
                                        </span>
                                    <?php endif; ?>
                                </div>
                            </div>
                            <div class="row pt-2">
                                <div class="col-lg-5 col-md-12 col-xs-12">
                                    <?= __('Consider downtimes'); ?>:
                                </div>
                                <div class="col-lg-7 col-md-12 col-xs-12">
                                    <span class="badge badge-success"
                                          ng-show="sla.consider_downtimes">
                                        <?= __('Yes'); ?>
                                    </span>
                                    <span class="badge badge-danger"
                                          ng-show="!sla.consider_downtimes">
                                        <?= __('No'); ?>
                                    </span>
                                </div>
                            </div>
                            <div class="row pt-2">
                                <div class="col-lg-5 col-md-12 col-xs-12">
                                    <?= __('Reflection state'); ?>:
                                </div>
                                <div class="col-lg-7 col-md-12 col-xs-12">
                                    <span ng-show="!sla.hard_state_only">
                                        <?= __('soft and hard state'); ?>
                                    </span>
                                    <span ng-show="sla.hard_state_only">
                                        <?= __('hard state only'); ?>
                                    </span>
                                </div>
                            </div>
                            <div class="row pt-2">
                                <div class="col-lg-5 col-md-12 col-xs-12">
                                    <?= __('Time period'); ?>:
                                </div>
                                <div class="col-lg-7 col-md-12 col-xs-12">
                                    {{sla.timeperiod.name}}
                                </div>
                            </div>
                        </div>
                        <div class="col-xs-12 col-md-12 col-sm-12 col-lg-8 col-xl-6">
                            <div class="row">
                                <div class="col-lg-3 col-md-12 col-xs-12">
                                    <div class="p-2 bg-danger rounded overflow-hidden position-relative text-white mb-g">
                                        <div>
                                            <h6 class="display-4 d-block l-h-n m-0 fw-500">
                                                <?php if ($this->Acl->hasPermission('index', 'hosts', '')): ?>
                                                    <span class="pointer"
                                                          ng-show="sla.hostsOverview.failed.count>0"
                                                          ui-sref="HostsIndex({id: sla.hostsOverview.failed.ids})">
                                                        {{sla.hostsOverview.failed.count}}
                                                    </span>
                                                    <span ng-hide="sla.hostsOverview.failed.count>0">
                                                        {{sla.hostsOverview.failed.count}}
                                                    </span>
                                                <?php else: ?>
                                                    {{sla.hostsOverview.failed.count}}
                                                <?php endif; ?>
                                                <small class="m-0 l-h-n">
                                                    <?= __('Failed'); ?>
                                                </small>
                                            </h6>
                                        </div>
                                        <i class="fa-solid fa-bolt position-absolute pos-right pos-bottom opacity-15 font-5-rem"></i>
                                    </div>
                                </div>
                                <div class="col-lg-3 col-md-12 col-xs-12">
                                    <div
                                            class="p-2 bg-warning rounded overflow-hidden position-relative text-white mb-g">
                                        <div>
                                            <h6 class="display-4 d-block l-h-n m-0 fw-500">
                                                <?php if ($this->Acl->hasPermission('index', 'hosts', '')): ?>
                                                    <span class="pointer"
                                                          ng-show="sla.hostsOverview.warning.count>0"
                                                          ui-sref="HostsIndex({id: sla.hostsOverview.warning.ids})">
                                                        {{sla.hostsOverview.warning.count}}
                                                    </span>
                                                    <span ng-hide="sla.hostsOverview.warning.count>0">
                                                        {{sla.hostsOverview.warning.count}}
                                                    </span>
                                                <?php else: ?>
                                                    {{sla.hostsOverview.warning.count}}
                                                <?php endif; ?>
                                                <small class="m-0 l-h-n">
                                                    <?= __('Warning'); ?>
                                                </small>
                                            </h6>
                                        </div>
                                        <i class="fa-solid fa-triangle-exclamation position-absolute pos-right pos-bottom opacity-15 font-5-rem"></i>
                                    </div>
                                </div>
                                <div class="col-lg-3 col-md-12 col-xs-12">
                                    <div
                                            class="p-2 bg-success rounded overflow-hidden position-relative text-white mb-g">
                                        <div>
                                            <h6 class="display-4 d-block l-h-n m-0 fw-500">
                                                <?php if ($this->Acl->hasPermission('index', 'hosts', '')): ?>
                                                    <span class="pointer"
                                                          ng-show="sla.hostsOverview.passed.count>0"
                                                          ui-sref="HostsIndex({id: sla.hostsOverview.passed.ids})">
                                                        {{sla.hostsOverview.passed.count}}
                                                    </span>
                                                    <span ng-hide="sla.hostsOverview.passed.count>0">
                                                        {{sla.hostsOverview.passed.count}}
                                                    </span>
                                                <?php else: ?>
                                                    {{sla.hostsOverview.passed.count}}
                                                <?php endif; ?>
                                                <small class="m-0 l-h-n">
                                                    <?= __('Passed'); ?>
                                                </small>
                                            </h6>
                                        </div>
                                        <i class="fa-solid fa-check position-absolute pos-right pos-bottom opacity-15 font-5-rem"></i>
                                    </div>
                                </div>
                                <div class="col-lg-3 col-md-12 col-xs-12">
                                    <div
                                            class="p-2 bg-primary rounded overflow-hidden position-relative text-white mb-g">
                                        <div>
                                            <h6 class="display-4 d-block l-h-n m-0 fw-500">
                                                <?php if ($this->Acl->hasPermission('index', 'hosts', '')): ?>
                                                    <span class="pointer"
                                                          ng-show="sla.hostsOverview.not_calculated.count>0"
                                                          ui-sref="HostsIndex({id: sla.hostsOverview.not_calculated.ids})">
                                                        {{sla.hostsOverview.not_calculated.count}}
                                                    </span>
                                                    <span ng-hide="sla.hostsOverview.not_calculated.count>0">
                                                        {{sla.hostsOverview.not_calculated.count}}
                                                    </span>
                                                <?php else: ?>
                                                    {{sla.hostsOverview.not_calculated.count}}
                                                <?php endif; ?>

                                                <small class="m-0 l-h-n">
                                                    <?= __('Not calculated'); ?>
                                                </small>
                                            </h6>
                                        </div>
                                        <i class="fa-solid fa-question position-absolute pos-right pos-bottom opacity-15 font-5-rem"></i>
                                    </div>
                                </div>
                            </div>
                            <div class="row">
                                <div class="col-lg-12 col-md-12 col-xs-12">
                                    <div class="gridContainer-weekdays">
                                        <?php foreach ($weekdays as $weekday): ?>
                                            <div class="child grid bg-primary text-white small">
                                                <?= $weekday; ?>
                                            </div>
                                        <?php endforeach; ?>
                                        <div class="child grid" ng-repeat="weekDay in sla.weekDays">
                                    <span ng-show="weekDay.length === 0">
                                        <i class="fa-solid fa-minus text-danger"></i>
                                    </span>
                                            <ul class="no-padding inside-list fw-300" ng-show="weekDay.length > 0">
                                                <li ng-repeat="timeDetails in weekDay">
                                                    {{timeDetails.start}} - {{timeDetails.end}}
                                                </li>
                                            </ul>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="row padding-top-10 padding-bottom-10">
                        <div class="col-lg-7 col-md-12 col-xs-12">
                            <sla-hosts-overview ng-if="sla" sla="sla">

                            </sla-hosts-overview>
                        </div>
                        <div class="col-lg-5 col-md-12 col-xs-12"
                             ng-show="slaDetails">
                            <div class="row padding-top-10">
                                <div class="col-lg-9 bold">
                                    <?= __('Host'); ?>
                                    <sub class="text-secondary">
                                        <?= __('limit 10'); ?>
                                    </sub>
                                </div>
                                <div class="col-lg-3 bold">
                                    <?= __('Achieved'); ?>(%)
                                    <i class="fa-solid fa-arrow-down-short-wide sla-service-list-icon font-md"></i>
                                </div>
                                <hr class="mt-1 mb-1 w-100"/>
                                <div ng-repeat-start="slaDetail in sla.hostsOverview.top10"
                                     class="col-lg-9 ellipsis">
                                    <?php if ($this->Acl->hasPermission('browser', 'hosts')): ?>
                                        <a ui-sref="HostsBrowser({id:slaDetail.id})">
                                            {{slaDetail.name}}
                                        </a>
                                    <?php else: ?>
                                        {{slaDetail.name}}
                                    <?php endif; ?>

                                </div>
                                <div class="col-lg-3 text-{{slaDetail.state}}" ng-repeat-end>
                                    {{slaDetail.determined_availability}}%
                                </div>
                            </div>
                        </div>
                    </div>
                    <!-- Start Filter -->
                    <div class="list-filter card margin-bottom-10" ng-show="showFilter">
                        <div class="card-header">
                            <i class="fa fa-filter"></i> <?= __('Filter'); ?>
                        </div>
                        <div class="card-body">
                            <div class="row">
                                <div class="col-xs-12 col-md-6 margin-bottom-10">
                                    <div class="form-group">
                                        <div class="input-group">
                                            <div class="input-group-prepend">
                                                <span class="input-group-text"><i
                                                            class="fa fa-filter"></i></span>
                                            </div>
                                            <input type="text" class="form-control form-control-sm"
                                                   placeholder="<?= __('Filter by host name'); ?>"
                                                   ng-model="filter.Hosts.name"
                                                   ng-model-options="{debounce: 500}">
                                        </div>
                                    </div>
                                </div>

                                <div class="col-xs-12 col-md-6 margin-bottom-10">
                                    <div class="form-group">
                                        <div class="input-group">
                                            <div class="input-group-prepend">
                                                <span class="input-group-text">
                                                    <i class="fa-solid fa-less-than-equal"></i>
                                                </span>
                                            </div>
                                            <input type="number" class="form-control form-control-sm" step="any"
                                                   placeholder="0" min="0" max="100"
                                                   ng-model="filter.determined_availability.from"
                                                   ng-model-options="{debounce: 500}">
                                            <span class="input-group-text">
                                                <i class="fa-solid fa-greater-than-equal"></i>
                                            </span>
                                            <input type="number" class="form-control form-control-sm" step="any"
                                                   placeholder="100" min="0" max="100"
                                                   ng-model="filter.determined_availability.to"
                                                   ng-model-options="{debounce: 500}">
                                        </div>
                                    </div>
                                </div>
                            </div>

                            <div class="float-right">
                                <button type="button" ng-click="resetFilter()"
                                        class="btn btn-xs btn-danger">
                                    <?= __('Reset Filter'); ?>
                                </button>
                            </div>
                        </div>
                    </div>
                    <!-- End Filter -->

                    <div class="frame-wrap">
                        <div class="col-lg-12 padding-10">
                            <table class="table table-bordered table-sm">
                                <thead>
                                <tr>
                                    <th class="no-sort" ng-click="orderBy('Hosts.name')">
                                        <i class="fa" ng-class="getSortClass('Hosts.name')"></i>
                                        <?= __('Host'); ?>
                                    </th>
                                    <th>
                                        <?= __('Total time'); ?>
                                    </th>
                                    <th>
                                        <?= __('Availability time'); ?>
                                    </th>
                                    <th>
                                        <?= __('Outage time'); ?>
                                    </th>
                                    <th>
                                        <?= __('Last update'); ?>
                                    </th>
                                    <th>
                                        <?= __('Goal'); ?>(%)
                                    </th>
                                    <th>
                                        <?= __(' Achieved'); ?>(%)
                                        <span class="pull-right">
                                            <i class="fa-solid fa-arrow-down-short-wide sla-service-list-icon font-md"></i>
                                        </span>
                                    </th>
                                    <th>
                                        <?= __('Status'); ?>
                                    </th>
                                    <th class="no-sort text-center editItemWidth">
                                        <i class="fa fa-gear fa-lg"></i>
                                    </th>
                                </tr>
                                </thead>
                                <tbody>
                                <tr ng-repeat-start="hostStatus in slaDetails"
                                    class="btn-{{hostStatus.state}}-opacity pl-1">
                                    <td>
                                        <i class="fa-solid fa-desktop fa-lg"></i>
                                        <span class="pl-1">
                                             <?php if ($this->Acl->hasPermission('browser', 'hosts')): ?>
                                                 <a ui-sref="HostsBrowser({id:hostStatus.host.id})">
                                                    {{hostStatus.host.name}}
                                                </a>
                                             <?php else: ?>
                                                 {{hostStatus.host.name}}
                                             <?php endif; ?>
                                        </span>
                                    </td>
                                    <td>
                                        {{hostStatus.evaluation_total_time_human_readable}}
                                    </td>
                                    <td>
                                        {{hostStatus.determined_availability_time_human_readable}}
                                    </td>
                                    <td>
                                        {{hostStatus.determined_outage_time_human_readable}}
                                    </td>
                                    <td>
                                        {{hostStatus.evaluation_end}}
                                    </td>
                                    <td>
                                        {{sla.minimal_availability}}%
                                    </td>
                                    <td>
                                        {{hostStatus.determined_availability_percent}}%
                                    </td>
                                    <td>
                                        <span class="badge border w-100"
                                              ng-hide="hostStatus.state === 'danger'">
                                            <?= __('PASSED') ?>
                                        </span>
                                        <span class="badge border w-100"
                                              ng-show="hostStatus.state === 'danger'">
                                            <?= __('FAILED') ?>
                                        </span>
                                    </td>
                                    <td class="text-center">
                                        <div class="btn-group btn-danger btn-group-xs" role="group">
                                            <?php if ($this->Acl->hasPermission('index', 'SlaAvailabilityStatusHostsLog', 'SLAModule')): ?>
                                                <a ui-sref="SlaAvailabilityStatusHostsLog({id:hostStatus.host.id})"
                                                   class="btn btn-danger btn-lower-padding">
                                                    <i class="fa-solid fa-list-check"></i>
                                                </a>
                                            <?php else: ?>
                                                <a href="javascript:void(0);"
                                                   class="btn btn-danger btn-lower-padding disabled">
                                                    <i class="fa-solid fa-list-check"></i>
                                                </a>
                                            <?php endif; ?>
                                            <button type="button"
                                                    class="btn btn-danger dropdown-toggle btn-lower-padding"
                                                    data-toggle="dropdown">
                                                <i class="caret"></i>
                                            </button>
                                            <div class="dropdown-menu dropdown-menu-right">
                                                <?php if ($this->Acl->hasPermission('index', 'SlaAvailabilityStatusHostsLog', 'SLAModule')): ?>
                                                    <a ui-sref="SlaAvailabilityStatusHostsLog({id:hostStatus.host.id})"
                                                       class="dropdown-item">
                                                        <i class="fa-solid fa-list-check"></i>
                                                        <?= __('View status log'); ?>
                                                    </a>
                                                <?php endif; ?>
                                            </div>
                                        </div>
                                    </td>
                                </tr>
                                <tr ng-repeat="serviceStatus in hostStatus.sla_availability_status_services"
                                    ng-repeat-end>
                                    <td class="pl-3">
                                        <span class="border-left border-{{serviceStatus.state}} pl-1 border-5">
                                             <?php if ($this->Acl->hasPermission('browser', 'services')): ?>
                                                 <a ui-sref="ServicesBrowser({id:serviceStatus.service_id})">
                                                    {{serviceStatus.servicename}}
                                                </a>
                                             <?php else: ?>
                                                 {{serviceStatus.servicename}}
                                             <?php endif; ?>
                                        </span>
                                    </td>
                                    <td>
                                        {{serviceStatus.evaluation_total_time_human_readable}}
                                    </td>
                                    <td>
                                        {{serviceStatus.determined_availability_time_human_readable}}
                                    </td>
                                    <td>
                                        {{serviceStatus.determined_outage_time_human_readable}}
                                    </td>
                                    <td>
                                        {{serviceStatus.evaluation_end}}
                                    </td>
                                    <td>
                                        {{sla.minimal_availability}}%
                                    </td>
                                    <td class="text-{{serviceStatus.state}}">
                                        {{serviceStatus.determined_availability_percent}}%
                                    </td>
                                    <td>
                                        <span class="badge border border-success text-success w-100"
                                              ng-hide="serviceStatus.state === 'danger'">
                                            <?= __('PASSED') ?>
                                        </span>
                                        <span class="badge border border-danger text-danger w-100"
                                              ng-show="serviceStatus.state === 'danger'">
                                            <?= __('FAILED') ?>
                                        </span>
                                    </td>
                                    <td class="text-center">
                                        <div class="btn-group btn-group-xs" role="group">
                                            <?php if ($this->Acl->hasPermission('index', 'SlaAvailabilityStatusServicesLog', 'SLAModule')): ?>
                                                <a ui-sref="SlaAvailabilityStatusServicesLog({id: serviceStatus.service_id})"
                                                   class="btn btn-default btn-lower-padding">
                                                    <i class="fa-solid fa-list-check"></i>
                                                </a>
                                            <?php else: ?>
                                                <a href="javascript:void(0);"
                                                   class="btn btn-default btn-lower-padding disabled">
                                                    <i class="fa-solid fa-list-check"></i>
                                                </a>
                                            <?php endif; ?>
                                            <button type="button"
                                                    class="btn btn-default dropdown-toggle btn-lower-padding"
                                                    data-toggle="dropdown">
                                                <i class="caret"></i>
                                            </button>
                                            <div class="dropdown-menu dropdown-menu-right">
                                                <?php if ($this->Acl->hasPermission('index', 'SlaAvailabilityStatusServicesLog', 'SLAModule')): ?>
                                                    <a ui-sref="SlaAvailabilityStatusServicesLog({id: serviceStatus.service_id})"
                                                       class="dropdown-item">
                                                        <i class="fa-solid fa-list-check"></i>
                                                        <?= __('View status log'); ?>
                                                    </a>
                                                <?php endif; ?>
                                            </div>
                                        </div>
                                    </td>
                                </tr>
                                </tbody>
                            </table>
                        </div>
                        <div class="margin-top-10" ng-show="slaDetails.length == 0">
                            <div class="text-center text-danger italic">
                                <?php echo __('No entries match the selection'); ?>
                            </div>
                        </div>

                        <scroll scroll="scroll" click-action="changepage" ng-if="scroll"></scroll>
                        <paginator paging="paging" click-action="changepage" ng-if="paging"></paginator>
                        <?php echo $this->element('paginator_or_scroll'); ?>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
