angular.module('openITCOCKPIT')
    .controller('SlaAvailabilityStatusServicesLogIndexController', function($scope, $http, $stateParams, SortService, MassChangeService){

        SortService.setSort('SlaAvailabilityStatusServicesLog.evaluation_start');
        SortService.setDirection('desc');

        $scope.id = $stateParams.id;
        $scope.currentPage = 1;
        $scope.useScroll = true;

        $scope.massChange = {};
        $scope.selectedElements = 0;

        var now = new Date();


        /*** Filter Settings ***/
        var defaultFilter = function(){
            var from = new Date(now.getTime() - (3600 * 24 * 30 * 1000));
            var to = new Date(now.getTime() + (3600 * 24 * 30 * 2 * 1000));

            if(typeof $stateParams.from !== "undefined" && $stateParams.from !== null){
                from = new Date($stateParams.from * 1000);
            }

            if(typeof $stateParams.to !== "undefined" && $stateParams.to !== null){
                to = new Date($stateParams.to * 1000);
            }

            from.setSeconds(0);
            to.setSeconds(0);

            $scope.filter = {
                from: date('d.m.Y H:i', from.getTime() / 1000),
                to: date('d.m.Y H:i', to.getTime() / 1000)
            };

            $scope.from_time = from;
            $scope.to_time = to;
        };
        /*** Filter end ***/
        $scope.init = true;
        $scope.showFilter = false;


        $scope.load = function(){
            $http.get("/sla_module/sla_availability_status_services_log/index/" + $scope.id + ".json", {
                params: {
                    'angular': true,
                    'scroll': $scope.useScroll,
                    'sort': SortService.getSort(),
                    'page': $scope.currentPage,
                    'direction': SortService.getDirection(),
                    'filter[from]': $scope.filter.from,
                    'filter[to]': $scope.filter.to
                }
            }).then(function(result){
                $scope.slaServiceStatusLog = result.data.slaServiceStatusLog;
                $scope.service = result.data.service;
                $scope.paging = result.data.paging;
                $scope.scroll = result.data.scroll;
                $scope.init = false;
            });
        };

        $scope.triggerFilter = function(){
            $scope.showFilter = !$scope.showFilter === true;
        };

        $scope.resetFilter = function(){
            defaultFilter();
            $scope.undoSelection();
        };

        $scope.changepage = function(page){
            if(page !== $scope.currentPage){
                $scope.currentPage = page;
                $scope.load();
            }
        };

        $scope.changeMode = function(val){
            $scope.useScroll = val;
            $scope.load();
        };

        $scope.undoSelection = function(){
            MassChangeService.clearSelection();
            $scope.massChange = MassChangeService.getSelected();
            $scope.selectedElements = MassChangeService.getCount();
        };

        $scope.selectAll = function(){
            if($scope.slas){
                for(var key in $scope.slas){
                    if($scope.slas[key].allowEdit){
                        var id = $scope.slas[key].id;
                        $scope.massChange[id] = true;
                    }
                }
            }
        };

        //Fire on page load
        defaultFilter();
        SortService.setCallback($scope.load);

        jQuery(function(){
            $("input[data-role=tagsinput]").tagsinput();
        });


        $scope.$watch('filter', function(){
            $scope.currentPage = 1;
            $scope.load();
        }, true);

        $scope.$watch('from_time', function(dateObject){
            if(dateObject !== undefined && dateObject instanceof Date){
                var dateString = date('d.m.Y H:i', dateObject.getTime() / 1000);
                $scope.filter.from = dateString;
            }
        });
        $scope.$watch('to_time', function(dateObject){
            if(dateObject !== undefined && dateObject instanceof Date){
                var dateString = date('d.m.Y H:i', dateObject.getTime() / 1000);
                $scope.filter.to = dateString;
            }
        });

        $scope.$watch('massChange', function(){
            MassChangeService.setSelected($scope.massChange);
            $scope.selectedElements = MassChangeService.getCount();
        }, true);
    });
