angular.module('openITCOCKPIT')
    .controller('SlasAddController', function($scope, $http, $state, NotyService, RedirectService){

        $scope.init = true;
        $scope.hasError = null;


        $scope.post = {
            container_id: null,
            timeperiod_id: null,
            name: '',
            description: '',
            minimal_availability: null,
            warning_threshold: null,
            start_date: null,
            evaluation_interval: 'MONTH',
            consider_downtimes: 1,
            hard_state_only: 0
        };

        $scope.errors = {};

        $scope.loadContainers = function(){
            $http.get("/containers/loadContainers.json", {
                params: {
                    'angular': true
                }
            }).then(function(result){
                $scope.containers = result.data.containers;
                $scope.init = false;
            });
        };

        $scope.loadTimeperiods = function(){
            $http.get("/timeperiods/loadTimeperiodsByContainerId.json", {
                params: {
                    'angular': true,
                    'containerId': $scope.post.container_id
                }
            }).then(function(result){
                $scope.timeperiods = result.data.timeperiods;
            });
        };


        $scope.submit = function(redirectState){
            console.log(redirectState);
            $http.post("/sla_module/slas/add.json?angular=true",
                $scope.post
            ).then(function(result){
                var url = $state.href('SlasEdit', {id: result.data.sla.id});
                NotyService.genericSuccess({
                    message: '<u><a href="' + url + '" class="txt-color-white"> '
                        + $scope.successMessage.objectName
                        + '</a></u> ' + $scope.successMessage.message
                });

                if(typeof redirectState === "undefined"){
                    RedirectService.redirectWithFallback('SlasIndex');
                }else{
                    $state.go(redirectState, {
                        id: result.data.sla.id
                    }).then(function(){
                        NotyService.scrollTop();
                    });
                }
            }, function errorCallback(result){
                if(result.data.hasOwnProperty('error')){
                    NotyService.genericError();
                    $scope.errors = result.data.error;
                }
            });
        };
        $scope.$watch('post.container_id', function(){
            if($scope.init){
                return;
            }
            $scope.loadTimeperiods('');
        }, true);

        //Fire on page load
        $scope.loadContainers();

    });
