angular.module('openITCOCKPIT')
    .controller('SlasEditController', function($scope, $http, $stateParams, $state, NotyService, RedirectService){
        $scope.id = $stateParams.id;
        $scope.init = true;

        $scope.hasError = null;


        $scope.hasError = null;
        $scope.errors = {};


        $scope.load = function(){
            var params = {
                'angular': true
            };

            $http.get("/sla_module/slas/edit/" + $scope.id + ".json", {
                params: params
            }).then(function(result){
                    $scope.post = result.data.sla;
                    if($scope.post.start_date){
                        $scope.post.start_date = new Date($scope.post.start_date);
                    }
                    setTimeout(function(){
                        $scope.init = false;
                    }, 250);
                    $scope.loadContainers();
                    $scope.loadTimeperiods();
                },

                function errorCallback(result){
                    if(result.status === 403){
                        $state.go('403');
                    }

                    if(result.status === 404){
                        $state.go('404');
                    }
                }
            );
        };

        $scope.loadContainers = function(){
            $http.get("/containers/loadContainers.json", {
                params: {
                    'angular': true
                }
            }).then(function(result){
                $scope.containers = result.data.containers;
                $scope.init = false;
            });
        };

        $scope.loadTimeperiods = function(){
            $http.get("/timeperiods/loadTimeperiodsByContainerId.json", {
                params: {
                    'angular': true,
                    'containerId': $scope.post.container_id
                }
            }).then(function(result){
                $scope.timeperiods = result.data.timeperiods;
            });
        };

        $scope.submit = function(redirectState){
            $http.post("/sla_module/slas/edit/" + $scope.id + ".json?angular=true",
                $scope.post
            ).then(function(result){
                var url = $state.href('SlasEdit', {id: $scope.id});
                NotyService.genericSuccess({
                    message: '<u><a href="' + url + '" class="txt-color-white"> '
                        + $scope.successMessage.objectName
                        + '</a></u> ' + $scope.successMessage.message
                });

                if(typeof redirectState === "undefined"){
                    RedirectService.redirectWithFallback('SlasIndex');
                }else{
                    $state.go(redirectState, {
                        id: $scope.id
                    }).then(function(){
                        NotyService.scrollTop();
                    });
                }
            }, function errorCallback(result){
                if(result.data.hasOwnProperty('error')){
                    NotyService.genericError();
                    $scope.errors = result.data.error;
                }
            });
        };

        $scope.$watch('post.container_id', function(){
            if($scope.init){
                return;
            }
            $scope.loadTimeperiods('');
        }, true);


        //Fire on page load
        $scope.load();
    });
