angular.module('openITCOCKPIT')
    .controller('SlasGenerateReportController', function($rootScope, $scope, $stateParams, $http, $timeout, NotyService){
        $scope.init = true;
        $scope.errors = null;
        $scope.tabName = 'reportConfig';
        $scope.reportWasGenerated = false;
        var now = new Date();

        $scope.id = parseInt($stateParams.id, 10);

        $scope.post = {
            Sla: {
                id: $scope.id,
                format: 'html',
                from_date: date('d.m.Y', now.getTime() / 1000 - (3600 * 24 * 30)),
                to_date: date('d.m.Y', now.getTime() / 1000),
                evaluation: 2
            }
        };

        $scope.from = new Date(now.getTime() - (3600 * 24 * 30 * 1000));
        $scope.to = new Date(now.getTime());

        $scope.loadSlas = function(){
            $http.get("/sla_module/slas/generate.json", {
                params: {
                    'angular': true
                }
            }).then(function(result){
                $scope.slas = result.data.slas;
            });
        };

        $scope.submit = function(){
            // Update from and to date in $scope.post from date picker input fields
            $scope.post.Sla.from_date = date('d.m.Y', $scope.from.getTime() / 1000);
            $scope.post.Sla.to_date = date('d.m.Y', $scope.to.getTime() / 1000);

            if($scope.post.Sla.format === 'pdf' || $scope.post.Sla.format === 'zip'){ //zip => csv
                //Run POST request to check if the report could be generated at all / validation
                $scope.isGenerating = true;
                $scope.reportWasGenerated = false;
                $http.post("/sla_module/slas/generate.json",
                    $scope.post
                ).then(function(POSTresult){
                    $scope.errors = null;
                    $scope.report_error = null;

                    //Download PDF Report
                    var GETParams = {
                        'angular': true,
                        'Sla[id]': $scope.post.Sla.id,
                        'Sla[evaluation]': $scope.post.Sla.evaluation,
                        'Sla[from_date]': date('d.m.Y', $scope.from.getTime() / 1000),
                        'Sla[to_date]': date('d.m.Y', $scope.to.getTime() / 1000),
                    };

                    if($scope.post.Sla.format === 'pdf'){
                        $http.get("/sla_module/slas/generate.pdf", {
                            params: GETParams,
                            responseType: 'blob'
                        }).then(function(res){
                            $scope.isGenerating = false;
                            var blob = new Blob([res.data], {type: "application/pdf"});
                            saveAs(blob, POSTresult.data.filename);
                        });
                    }
                    if($scope.post.Sla.format === 'zip'){ //zip => csv
                        $http.get("/sla_module/slas/generate.zip", {
                            params: GETParams,
                            responseType: 'blob'
                        }).then(function(res){
                            $scope.isGenerating = false;
                            var blob = new Blob([res.data], {type: "application/zip"});
                            saveAs(blob, POSTresult.data.filename);
                        });
                    }


                }, function errorCallback(result){
                    $scope.isGenerating = false;
                    NotyService.genericError({
                        message: $scope.reportMessage.errorMessage
                    });
                    if(result.data.hasOwnProperty('error')){
                        $scope.errors = result.data.error;
                    }

                    if(result.data.hasOwnProperty('report_error')){
                        $scope.report_error = result.data.report_error;
                    }
                });

            }else{
                //HTML Report
                $scope.reportWasGenerated = false;
                $scope.isGenerating = true;
                $scope.post.Sla.from_date = date('d.m.Y', $scope.from.getTime() / 1000);
                $scope.post.Sla.to_date = date('d.m.Y', $scope.to.getTime() / 1000);
                $http.post("/sla_module/slas/generate.json",
                    $scope.post
                ).then(function(result){
                    $scope.report = [];
                    $scope.errors = null;
                    $scope.report_error = null;
                    $scope.tabName = 'showReport';
                    $scope.reportWasGenerated = true;
                    $scope.isGenerating = false;
                    $scope.report = result.data.report;
                    $scope.sla = result.data.sla;

                    NotyService.genericSuccess({
                        message: $scope.reportMessage.successMessage
                    });
                }, function errorCallback(result){
                    $scope.isGenerating = false;
                    NotyService.genericError({
                        message: $scope.reportMessage.errorMessage
                    });
                    if(result.data.hasOwnProperty('error')){
                        $scope.errors = result.data.error;
                    }

                    if(result.data.hasOwnProperty('report_error')){
                        $scope.report_error = result.data.report_error;
                    }
                });
            }
        };

        //Fire on page load
        $scope.loadSlas();
    });
