angular.module('openITCOCKPIT')
    .controller('SlasHostsController', function($scope, $http, $stateParams, SortService){

        SortService.setSort('Hosts.name');
        SortService.setDirection('asc');

        $scope.currentPage = 1;
        $scope.useScroll = true;
        $scope.id = $stateParams.id;

        /*** Filter Settings ***/
        var defaultFilter = function(){
            $scope.filter = {
                Hosts: {
                    name: ''
                }
            };
        };
        /*** Filter end ***/
        $scope.init = true;
        $scope.showFilter = false;


        $scope.load = function(){
            var params = {
                'angular': true,
                'scroll': $scope.useScroll,
                'sort': SortService.getSort(),
                'page': $scope.currentPage,
                'direction': SortService.getDirection(),
                'filter[Hosts.name]': $scope.filter.Hosts.name
            };
            $http.get("/sla_module/slas/hosts/" + $scope.id + ".json", {
                params: params
            }).then(function(result){
                    $scope.sla = result.data.sla;
                    $scope.hosts = result.data.hosts;
                    $scope.paging = result.data.paging;
                    $scope.scroll = result.data.scroll;
                    jQuery(function(){
                        $('.tagsinput').tagsinput();
                    });

                    setTimeout(function(){
                        $scope.init = false;
                    }, 250);
                },

                function errorCallback(result){
                    if(result.status === 403){
                        $state.go('403');
                    }

                    if(result.status === 404){
                        $state.go('404');
                    }
                }
            );
        };

        $scope.triggerFilter = function(){
            $scope.showFilter = !$scope.showFilter === true;
        };

        $scope.resetFilter = function(){
            defaultFilter();
        };


        $scope.changepage = function(page){
            if(page !== $scope.currentPage){
                $scope.currentPage = page;
                $scope.load();
            }
        };

        $scope.changeMode = function(val){
            $scope.useScroll = val;
            $scope.load();
        };


        //Fire on page load
        defaultFilter();
        SortService.setCallback($scope.load);

        $scope.$watch('filter', function(){
            $scope.currentPage = 1;
            $scope.load();
        }, true);
    });
