angular.module('openITCOCKPIT')
    .controller('SlasIndexController', function($scope, $http, SortService, MassChangeService){

        SortService.setSort('Slas.name');
        SortService.setDirection('asc');

        $scope.currentPage = 1;
        $scope.useScroll = true;

        $scope.massChange = {};
        $scope.selectedElements = 0;

        $scope.deleteUrl = '/sla_module/slas/delete/';


        /*** Filter Settings ***/
        var defaultFilter = function(){
            $scope.filter = {
                Slas: {
                    name: '',
                    description: ''
                }
            };
        };
        /*** Filter end ***/
        $scope.init = true;
        $scope.showFilter = false;


        $scope.load = function(){
            var params = {
                'angular': true,
                'scroll': $scope.useScroll,
                'sort': SortService.getSort(),
                'page': $scope.currentPage,
                'direction': SortService.getDirection(),
                'filter[Slas.name]': $scope.filter.Slas.name,
                'filter[Slas.description]': $scope.filter.Slas.description
            };
            $http.get("/sla_module/slas/index.json", {
                    params: params

                }
            ).then(function(result){
                $scope.slas = result.data.slas;
                $scope.paging = result.data.paging;
                $scope.scroll = result.data.scroll;
                $scope.init = false;
            });
        };

        $scope.triggerFilter = function(){
            $scope.showFilter = !$scope.showFilter === true;
        };

        $scope.resetFilter = function(){
            defaultFilter();
            $scope.undoSelection();
        };

        $scope.changepage = function(page){
            if(page !== $scope.currentPage){
                $scope.currentPage = page;
                $scope.load();
            }
        };

        $scope.changeMode = function(val){
            $scope.useScroll = val;
            $scope.load();
        };

        $scope.undoSelection = function(){
            MassChangeService.clearSelection();
            $scope.massChange = MassChangeService.getSelected();
            $scope.selectedElements = MassChangeService.getCount();
        };

        $scope.selectAll = function(){
            if($scope.slas){
                for(var key in $scope.slas){
                    if($scope.slas[key].allowEdit){
                        var id = $scope.slas[key].id;
                        $scope.massChange[id] = true;
                    }
                }
            }
        };

        $scope.getObjectsForDelete = function(){
            var objects = {};
            var selectedObjects = MassChangeService.getSelected();
            for(var key in $scope.slas){
                for(var id in selectedObjects){
                    if(id == $scope.slas[key].id){
                        objects[id] = $scope.slas[key].name;
                    }

                }
            }
            return objects;
        };

        $scope.getObjectForDelete = function(sla){
            var object = {};
            object[sla.id] = sla.name;
            return object;
        };

        //Fire on page load
        defaultFilter();
        SortService.setCallback($scope.load);

        jQuery(function(){
            $("input[data-role=tagsinput]").tagsinput();
        });


        $scope.$watch('filter', function(){
            $scope.currentPage = 1;
            $scope.load();
        }, true);

        $scope.$watch('massChange', function(){
            MassChangeService.setSelected($scope.massChange);
            $scope.selectedElements = MassChangeService.getCount();
        }, true);
    });
