angular.module('openITCOCKPIT').directive('slaAvailabilityOverview', function($http){
    return {
        restrict: 'E',
        templateUrl: '/sla_module/Slas/slaAvailabilityOverview.html',
        scope: {
            'sla': '=',
            'availability': '='
        },
        controller: function($scope){

            var renderPieChart = function(){
                var passed = $scope.availability.status_percent;
                var failed = 100 - passed;

                var ctx = document.getElementById("slaPieChart");
                var slaPieChart = new Chart(ctx, {
                    type: 'pie',
                    data: {
                        labels: [$('#t-chart-failed').data('text'), $('#t-chart-passed').data('text')],
                        datasets: [{
                            backgroundColor: ["#CC0000ff", "#00C851"],
                            data: [failed.toFixed(3), passed.toFixed(3)]
                        }]
                    },
                    options: {
                        title: {
                            display: true,
                            text: $('#t-chart-legend').data('text')+' '+passed+' %',
                            fontSize:18,
                            fontStyle: 'normal'
                        },
                        //responsive: true,
                        legend: {
                            position: 'right'
                        },
                    }
                });
            };

            //Fire on page load
            renderPieChart();


        },

        link: function($scope, element, attr){
            element.ready(function(){

            });
        }
    };
});
