angular.module('openITCOCKPIT').directive('slaHostInformationElement', function($http){
    return {
        restrict: 'E',
        templateUrl: '/sla_module/Slas/slaHostInformation.html',
        scope: {
            'hostId': '@'
        },

        controller: function($scope){
            $scope.init = false;
            $scope.sla_information = null;
            $scope.load = function(){
                $http.get("/sla_module/Slas/slaHostInformation/" + $scope.hostId + ".json", {
                    params: {
                        'angular': true
                    }
                }).then(function(result){
                    $scope.sla_information = result.data.response;
                    $scope.sla = result.data.sla;
                    $scope.sla.weekDays = [];
                    for(var i = 0; i <= 6; i++){
                        // Array required to keep order
                        $scope.sla.weekDays[i] = [];
                    }


                    for(var key in $scope.sla.timeperiod.timeperiod_timeranges){
                        var timeRange = $scope.sla.timeperiod.timeperiod_timeranges[key];
                        // Server day 1 - 7
                        // JavaScript days 0 - 6 to get an array (array has to start with 0!) :(
                        var day = timeRange.day - 1;
                        $scope.sla.weekDays[day].push({
                            start: timeRange.start,
                            end: timeRange.end
                        });
                    }
                }, function errorCallback(result){
                    if(result.status === 404){
                        window.location.href = '/angular/not_found';
                    }
                });
            };

            $scope.load();
        },

        link: function($scope, element, attr){
        }
    };
});
