angular.module('openITCOCKPIT').directive('slaHostsOverview', function($http){
    return {
        restrict: 'E',
        templateUrl: '/sla_module/Slas/slaHostsOverview.html',
        scope: {
            'sla': '='
        },
        controller: function($scope){
            const width = 100; // 0 to 100
            const height = 1;

            var context = null;

            var initCanvas = function(){// gradientColors [colorA, colorB, ..]
                // Canvas
                const canvasElement = document.createElement("CANVAS");
                canvasElement.width = width;
                canvasElement.height = height;

                /*
                // Gradient is disabled for now - colors where hard to determine if it is warning or not
                context = canvasElement.getContext("2d");
                // Gradient

                const gradient = context.createLinearGradient(0, 0, width, 0); // x0, y0, x1, y1

                if($scope.sla.minimal_availability){
                    gradient.addColorStop($scope.sla.minimal_availability / 100, '#CC0000');
                    if(!$scope.sla.warning_threshold){
                        gradient.addColorStop($scope.sla.minimal_availability / 100, '#00C851');
                    }
                }
                if($scope.sla.warning_threshold){
                    gradient.addColorStop($scope.sla.warning_threshold / 100, '#ffbb33');
                    gradient.addColorStop($scope.sla.warning_threshold / 100, '#00C851');
                }

                gradient.addColorStop(1, '#00C851');

                // Fill with gradient
                context.fillStyle = gradient;
                context.fillRect(0, 0, width, height); // x, y, width, height
                 */


            }

            var getColor = function(percent){ // percent [0..100]
                if(percent !== null){
                    if(percent < $scope.sla.minimal_availability){
                        return '#CC0000';
                    }

                    if($scope.sla.warning_threshold){
                        if(percent < $scope.sla.warning_threshold){
                            return '#ffbb33';
                        }
                    }

                    return '#00C851';
                }

                // Gradient (disabled at the moment)
                /*
                if(percent !== null){
                    const color = context.getImageData(percent, 0, 1, 1); // x, y, width, height
                    const rgba = color.data;
                    return `rgb(${rgba[0]}, ${rgba[1]}, ${rgba[2]})`;
                }
                 */
            }

            initCanvas();

            var canvas = document.getElementById("chart");
            var ctx = canvas.getContext('2d');
            var percentValues = [];
            var hostNames = [];
            for(var i = 0; i < 10; i++){
                if($scope.sla.hostsOverview.top10[i]){
                    percentValues.push($scope.sla.hostsOverview.top10[i].determined_availability);
                    hostNames.push($scope.sla.hostsOverview.top10[i].name);
                }else{
                    percentValues.push(null);
                    hostNames.push("");
                }
            }
            var data = {
                labels: hostNames,
                datasets: [
                    {
                        label: $('#canvas-holder').data('text'),
                        data: percentValues,
                        borderWidth: 1,
                        backgroundColor: getColorEachBar(percentValues.length, percentValues)
                    }
                ]
            };

            function getColorEachBar(count, percentValues){
                var data = [];
                percentValues.forEach(function(value){
                    data.push(getColor(value));
                });
                return data;
            }

            var options = {
                clip: false,
                layout: {
                    padding: {
                        // Any unspecified dimensions are assumed to be 0
                        left: 10,
                        top: 5,
                        right: 40
                    }
                },
                legend: {
                    labels: {
                        boxWidth: 0,
                    }
                },

                tooltips: {
                    enabled: false,
                },
                events: [],
                hover: {mode: null},

                animation: {
                    duration: 1,
                    onComplete: function(){
                        var chartInstance = this.chart,
                            ctx = chartInstance.ctx;
                        ctx.textAlign = 'center';
                        ctx.textBaseline = 'bottom';
                        ctx.font = '12px serif';

                        this.data.datasets.forEach(function(dataset, i){
                            var meta = chartInstance.controller.getDatasetMeta(i);
                            meta.data.forEach(function(bar, index){
                                if(bar._model.y){
                                    var data = dataset.data[index];
                                    //60 = bar._model.y show availability always on top
                                    ctx.fillText(data, bar._model.x, 60);
                                }
                            });
                        });
                    }
                },
                scales: {
                    xAxes: [{
                        display: true,
                        ticks: {
                            fontSize: 10,
                            beginAtZero: true,
                            minRotation: 15,
                            maxRotation: 15,
                            callback: function(value){
                                if(value.length > 20){
                                    return value.substr(0, 20) + '...'; //truncate
                                }else{
                                    return value;
                                }
                            }
                        },
                    }],
                    yAxes: [{
                        ticks: {
                            fontSize: 9,
                            min: 0,
                            max: 100,
                            callback: function(value){
                                return (value / this.max * 100).toFixed(0) + '%'; // convert it to percentage
                            },
                        },
                        scaleLabel: {
                            display: true,
                            labelString: '%',
                        },
                    }],
                }
            };
            var annotations = [];
            annotations.push({
                id: 'criticalLine',
                type: 'line',
                mode: 'horizontal',
                scaleID: 'y-axis-0',
                value: $scope.sla.minimal_availability,
                borderColor: '#CC0000aa',
                borderWidth: 1,
                padding: 1,
                label: {
                    backgroundColor: "#CC0000",
                    backgroundShadowColor: 'black',
                    content: $scope.sla.minimal_availability + '%',
                    enabled: true,
                    position: "right",
                    fontSize: 10,
                    xPadding: 3,
                    yPadding: 2,
                    yAdjust: ($scope.sla.minimal_availability >= 95) ? 2 : 0
                }
            });

            if($scope.sla.warning_threshold){
                annotations.push({
                    id: 'warningLine',
                    type: 'line',
                    mode: 'horizontal',
                    scaleID: 'y-axis-0',
                    value: $scope.sla.warning_threshold,
                    borderColor: '#ce8905cc',
                    borderWidth: 1,
                    label: {
                        backgroundColor: "#E89D10FF",
                        backgroundShadowColor: 'black',
                        content: $scope.sla.warning_threshold + '%',
                        enabled: true,
                        position: "center",
                        fontSize: 10,
                        xPadding: 3,
                        yPadding: 2,
                        yAdjust: ($scope.sla.warning_threshold >= 95) ? 2 : 0
                    }
                });
            }


            options.annotation = {
                drawTime: 'afterDatasetsDraw',
                annotations: annotations

            };

            // Chart declaration:
            var multiLineChart = new Chart(ctx, {
                type: 'bar',
                data: data,
                options: options,
                plugins: {
                    beforeInit(chart){
                        // Get reference to the original fit function
                        const originalFit = chart.legend.fit;

                        // Override the fit function
                        chart.legend.fit = function fit(){
                            // Call original function and bind scope in order to use `this` correctly inside it
                            originalFit.bind(chart.legend)();
                            // Change the height as suggested in another answers
                            this.height += 25;
                        }
                    }
                }
            });

            var colorGradient = function(fadeFraction, rgbColor1, rgbColor2, rgbColor3){
                var color1 = rgbColor1;
                var color2 = rgbColor2;
                var fade = fadeFraction;

                // Do we have 3 colors for the gradient? Need to adjust the params.
                if(rgbColor3){
                    fade = fade * 2;
                    // Find which interval to use and adjust the fade percentage
                    if(fade >= 1){
                        fade -= 1;
                        color1 = rgbColor2;
                        color2 = rgbColor3;
                    }
                }

                var diffRed = color2.red - color1.red;
                var diffGreen = color2.green - color1.green;
                var diffBlue = color2.blue - color1.blue;

                var gradient = {
                    red: parseInt(Math.floor(color1.red + (diffRed * fade)), 10),
                    green: parseInt(Math.floor(color1.green + (diffGreen * fade)), 10),
                    blue: parseInt(Math.floor(color1.blue + (diffBlue * fade)), 10),
                };

                return 'rgb(' + gradient.red + ',' + gradient.green + ',' + gradient.blue + ')';
            }
        },

        link: function($scope, element, attr){
        }
    };
});
