angular.module('openITCOCKPIT').directive('slaWidget', function($http){
    return {
        restrict: 'E',
        templateUrl: '/sla_module/slas/slaWidget.html',
        scope: {
            'widget': '='
        },

        controller: function($scope){
            /** public vars **/
            $scope.init = true;
            $scope.slaConfig = {
                id: null
            };

            var $widget = $('#widget-' + $scope.widget.id);

            $scope.frontWidgetHeight = parseInt(($widget.height() - 80), 10); //-80px header
            $scope.frontWidgetWidth = parseInt(($widget.width() - 30), 10); //-30px padding from grid + padding from widget
            $scope.SlaAvailabilityView = [];

            $widget.on('resize', function(){
                if($scope.init){
                    return;
                }
                hasResize();
            });

            $scope.slaOverviewTimeout = null;

            $scope.load = function(){
                $http.get("/sla_module/slas/slaWidget.json", {
                    params: {
                        'angular': true,
                        'widgetId': $scope.widget.id
                    }
                }).then(function(result){
                    $scope.sla = result.data.sla;
                    $scope.slaConfig = result.data.config;
                    $scope.slaConfig.id = parseInt(result.data.config.Sla.id, 10);

                    if($scope.sla.id !== null){
                        $scope.SlaAvailabilityView = $scope.sla.hostsAndServicesOverview;
                    }
                    $scope.fontSize = parseInt($scope.frontWidgetHeight / 8.5, 10);

                    $scope.ACL = result.data.ACL;
                    $scope.slaHref = getHref();
                    //Do not trigger watch on page load
                    setTimeout(function(){
                        $scope.init = false;
                    }, 250);
                });
            };

            $scope.hideConfig = function(){
                $scope.$broadcast('FLIP_EVENT_IN');
                $scope.load();
            };
            $scope.showConfig = function(){
                $scope.$broadcast('FLIP_EVENT_OUT');
                $scope.loadSlas();
            };


            var hasResize = function(){
                if($scope.init){
                    return;
                }
                $scope.frontWidgetHeight = parseInt(($widget.height() - 80), 10); //-80px header
                $scope.frontWidgetWidth = parseInt(($widget.width() - 30), 10); //-12px padding from grid + padding from widget

                $scope.fontSize = parseInt($scope.frontWidgetHeight / 8.5, 10);

                if($scope.slaOverviewTimeout){
                    clearTimeout($scope.slaOverviewTimeout);
                }
                $scope.slaOverviewTimeout = setTimeout(function(){
                    $scope.load();
                }, 500);
            };

            $scope.loadSlas = function(){
                $http.get("/sla_module/slas/loadSlas.json", {
                    params: {
                        'angular': true
                    }
                }).then(function(result){
                    $scope.slas = result.data.slas;
                });
            };


            $scope.saveSlaWidget = function(){
                $http.post("/sla_module/slas/slaWidget.json?angular=true",
                    {
                        Widget: {
                            id: $scope.widget.id
                        },
                        Sla: {
                            id: $scope.slaConfig.id
                        },
                    }
                ).then(function(result){
                    //Update status
                    $scope.hideConfig();
                });
            };

            var getHref = function(){
                var url = 'javascript:void(0);';
                if($scope.ACL.sla.viewdetails){
                    return '/sla_module/slas/viewDetails/' + $scope.slaConfig.id
                }

                return url;
            };

            /** Page load / widget get loaded **/
            $scope.load();
        },

        link: function($scope, element, attr){

        }
    };
});
