angular.module('openITCOCKPIT').directive('timeperiodDetailsTooltip', function($http, $compile, $timeout){
    return {
        restrict: 'E',
        templateUrl: '/sla_module/slas/timeperiodDetailsTooltip.html',
        scope: {
            'timeperiodId': '='
        },

        controller: function($scope){
            $scope.loadTimeperiodDetails = function(){
                $http.get("/timeperiods/viewDetails/" + $scope.timeperiodId + ".json", {
                    params: {
                        'angular': true
                    }
                }).then(function(result){
                    $scope.timeperiod = result.data.timeperiod;
                    $scope.weekDays = [];
                    for(var i = 0; i <= 6; i++){
                        // Array required to keep order
                        $scope.weekDays[i] = [];
                    }


                    for(var key in $scope.timeperiod.timeperiod_timeranges){
                        var timerange = $scope.timeperiod.timeperiod_timeranges[key];
                        // Server day 1 - 7
                        // JavaScript days 0 - 6 to get an array (array has to start with 0!) :(
                        var day = timerange.day - 1;
                        $scope.weekDays[day].push({
                            start: timerange.start,
                            end: timerange.end
                        });
                    }

                    $scope.timerangesTableHtml = '';

                    var headerRow = document.createElement('tr');
                    var timespansRow = document.createElement('tr');

                    for(var key in $scope.weekDays){
                        var timeSpansExists = $scope.weekDays[key].length > 0 ? true : false;
                        var headerTd = document.createElement('td');
                        var headerDiv = document.createElement('div');
                        headerDiv.textContent = timeSpansExists ? $scope.label.messageExists : $scope.label.messageNotExists
                        headerDiv.classList.add('width-90', 'badge', 'badge-' + (timeSpansExists ? 'success' : 'danger'));
                        headerTd.append(headerDiv);
                        headerRow.append(headerTd);
                        if(timeSpansExists){
                            var timespanTd = document.createElement('td');
                            timespanTd.classList.add('text-center');
                            var timespanUl = document.createElement('ul');
                            timespanUl.classList.add('no-padding', 'inside-list');
                            for(index in $scope.weekDays[key]){
                                var timespanLi = document.createElement('li');
                                timespanLi.appendChild(
                                    document.createTextNode($scope.weekDays[key][index].start + ' - ' + $scope.weekDays[key][index].end)
                                );
                                timespanUl.append(timespanLi);
                            }
                            timespanTd.append(timespanUl);
                        }else{
                            var timespanTd = document.createElement('td');
                            timespanTd.classList.add('text-center', 'text-danger');
                            var icon = document.createElement('i');
                            icon.classList.add('fa-solid', 'fa-minus');
                            timespanTd.appendChild(icon);
                        }
                        timespansRow.append(timespanTd);
                    }

                    $scope.timerangesTableHtml = headerRow.outerHTML + timespansRow.outerHTML;

                    $('.timeperiodDetails').popover({
                        boundary: 'window',
                        trigger: 'hover',
                        placement: 'left',
                        container: 'body',
                        sanitize: false,
                        template: '<div class="popover bg-white-transparent" style="min-width: 500px;" role="tooltip"><div class="arrow"></div><h3 class="popover-header"></h3><div class="popover-body"></div></div>'
                    });
                });
            };
        },
        link: function($scope, $element, $attrs){
            $scope.$watch('timeperiodId', function(){
                $scope.loadTimeperiodDetails();
            });


        }
    };
});
